import { _decorator, Component, Node, LabelComponent } from 'cc';
import { SDKbaseView } from './SDKbaseView';
import { tyqSDK } from './tyq-sdk';
import { Toutiao } from './tyqToutiao';
const { ccclass, property } = _decorator;

@ccclass('sdk_shareVideo')
export class sdk_shareVideo extends SDKbaseView {

    start() {
        this.bindButton(this.node,this.upLoad);
    }
    /**上传 */
    public upLoad() {
        console.log("达人点击上传视频");
        tyqSDK.outMain();
        Toutiao.login().then(() => {
            console.log("登录");
            return Toutiao.getUserInfo();
        }).then((cres:any) => {
            console.log("授权");
            tyqSDK.RecordCut((res:any) => {
                console.log("分享视频返回值");
                console.log(res);
            }, this, cres)
        })
    }
}
