System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, DataManager, _crd;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "21bdbtbXChBkJaSLtlHH6Lh", "DataManager", undefined);

      DataManager = class DataManager {
        constructor() {
          _defineProperty(this, "data", {});
        }

        getTable(tableName) {
          return this.data[tableName];
        }

        handleData(tableName, arr) {
          // 获取首行提示符
          let tips = arr[0].split(','); // 获取第二行字段类型

          let types = arr[1].split(','); // 获取第三行字段名字

          let names = arr[2].split(','); // 处理剩余数据

          let table = {};

          for (let i = 3; i < arr.length; i++) {
            let single = arr[i].split(/,/g);
            let obj = this.singleData(names, types, single, tableName, single[0]);
            let key = single[0];
            table[key] = obj;
          } // 加入表格


          this.data[tableName] = table;
        }

        singleData(names, types, single, tableName, taK) {
          let obj = {};

          for (let i = 0; i < single.length; i++) {
            // 如果字段不存在则跳过
            if (!names[i]) {
              continue;
            } // 去除空格


            let key = names[i].replace(/\b\s*/g, "");
            let value = single[i].replace(/\b\s*/g, "");
            let typeName = types[i].replace(/\b\s*/g, ""); // 区分字段类型

            if (typeName == 'string') {
              obj[key] = value;
            } else if (typeName == "number") {
              obj[key] = Number(value);
            }
          }

          return obj;
        }

        GetTableByType(name, typename, type) {
          let list = [];
          let table = this.getTable(name);

          for (let i in table) {
            if (table[i][`${typename}`] == type) {
              list.push(table[i]);
            }
          }

          return list;
        }

        GetTableByID(name, id) {
          let tabeldata;
          let table = this.getTable(name);

          for (let i in table) {
            if (table[i].id == id) {
              tabeldata = table[i];
              return tabeldata;
            }
          }

          return tabeldata;
        }

      };

      _export("default", new DataManager());

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=DataManager.js.map