System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./FileSaver", "../config/global"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, Node, SaveAs, global, _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp, _crd, ccclass, property, LevelGame;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSaveAs(extras) {
    _reporterNs.report("SaveAs", "./FileSaver", _context.meta, extras);
  }

  function _reportPossibleCrUseOfglobal(extras) {
    _reporterNs.report("global", "../config/global", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
    }, function (_FileSaver) {
      SaveAs = _FileSaver.SaveAs;
    }, function (_configGlobal) {
      global = _configGlobal.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "688f2fXWQtL8rZyhMQyJEeR", "LevelGame", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("LevelGame", LevelGame = (_dec = ccclass('LevelGame'), _dec2 = property({
        tooltip: "关卡"
      }), _dec3 = property({
        type: Node
      }), _dec(_class = (_class2 = (_temp = class LevelGame extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "level", _descriptor, this);

          _initializerDefineProperty(this, "btn", _descriptor2, this);

          _defineProperty(this, "blob", void 0);
        }

        onLoad() {
          this.btn.on('click', () => {
            (_crd && SaveAs === void 0 ? (_reportPossibleCrUseOfSaveAs({
              error: Error()
            }), SaveAs) : SaveAs)(this.blob, "level" + this.level + ".csv");
          });
        }

        start() {
          if (this.node.active == true) {
            this.btn.active = true;
            this.btn.parent.active = true;
          } else {
            this.btn.active = false;
          }

          this.scheduleOnce(this.check, 1);
        }

        check() {
          var data1 = '';
          var index = 0;
          var da = '索引,' + '节点名字,' + 'posX,' + 'posY,' + 'posZ,' + 'rotX,' + 'rotY,' + 'rotZ,' + 'ScaX,' + 'ScaY,' + 'ScaZ,' + 'Type' + 'Type2' + '\n' + 'number,' + 'string,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number' + 'number' + '\n' + 'ID,' + 'name,' + 'posX,' + 'posY,' + 'posZ,' + 'rotX,' + 'rotY,' + 'rotZ,' + 'ScaX,' + 'ScaY,' + 'ScaZ,' + 'Type' + 'Type2' + '\n';
          data1 += da;

          for (let value of this.node.children) {
            index++;
            var type = 0;
            const nodeName = value.name; //道具分组

            if (nodeName == "prefab_group") {
              da = this.getNodeValueStr(value, index, type);
              data1 += da;

              for (let value2 of value.children) {
                index++;
                var type2 = 0;
                const nodeName2 = value2.name;
                var moveLength = 0; //特殊处理的道具 

                if ((_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
                  error: Error()
                }), global) : global).arrProp.indexOf(nodeName2) > -1) {
                  type2 = value2.getComponent(Props).Value;
                  moveLength = value2.getComponent(Props).moveLength;
                }

                da = this.getNodeValueStr(value2, index, type2, moveLength);
                data1 += da;
              }

              continue;
            }

            if (nodeName == "prefab_curve") {
              type = value.getComponent(prefab_curve).anger;
            }

            da = this.getNodeValueStr(value, index, type);
            data1 += da;
          }

          var content = data1;
          this.blob = new Blob([content], {
            type: "text/csv;charset=utf-8"
          });
        }

        getNodeValueStr(node, index, type, type2 = 0) {
          let str = index + ',' + node.name + "," + Number(node.position.x.toFixed(3)) + "," + Number(node.position.y.toFixed(3)) + "," + Number(node.position.z.toFixed(3)) + "," + Number(node.eulerAngles.x.toFixed(3)) + "," + Number(node.eulerAngles.y.toFixed(3)) + "," + Number(node.eulerAngles.z.toFixed(3)) + "," + Number(node.scale.x.toFixed(3)) + ',' + Number(node.scale.y.toFixed(3)) + "," + Number(node.scale.z.toFixed(3)) + "," + type + "," + type2 + '\n';
          return str;
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "level", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btn", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=LevelGame.js.map