System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./miniGamefram/game/BaseView"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, director, BaseView, _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp, _crd, ccclass, property, Test;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfBaseView(extras) {
    _reporterNs.report("BaseView", "./miniGamefram/game/BaseView", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      director = _cc.director;
    }, function (_miniGameframGameBaseView) {
      BaseView = _miniGameframGameBaseView.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "131a3G2iS5Em5veCA+oN4Hg", "test", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("Test", Test = (_dec = ccclass('Test'), _dec2 = property({
        type: Node,
        tooltip: "首次进入游戏"
      }), _dec3 = property({
        type: Node,
        tooltip: "主页"
      }), _dec4 = property({
        type: Node,
        tooltip: "开始游戏"
      }), _dec5 = property({
        type: Node,
        tooltip: "结束游戏"
      }), _dec6 = property({
        type: Node,
        tooltip: "切换场景"
      }), _dec(_class = (_class2 = (_temp = class Test extends (_crd && BaseView === void 0 ? (_reportPossibleCrUseOfBaseView({
        error: Error()
      }), BaseView) : BaseView) {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "inGame", _descriptor, this);

          _initializerDefineProperty(this, "mainGame", _descriptor2, this);

          _initializerDefineProperty(this, "startGame", _descriptor3, this);

          _initializerDefineProperty(this, "endGame", _descriptor4, this);

          _initializerDefineProperty(this, "loadScenen", _descriptor5, this);
        }

        start() {
          TyqSdk.init(() => {
            this.bindButton(this.inGame, () => {
              //进入游戏场景
              TyqSdk.inGameScene(this.node);
            });
            this.bindButton(this.mainGame, () => {
              TyqSdk.showMain();
            });
            this.bindButton(this.startGame, () => {
              TyqSdk.startGame(1, () => {
                this.startGameFun();
              });
            });
            this.bindButton(this.endGame, () => {
              TyqSdk.endGame("lose", () => {
                this.endGameFun();
              });
            });
            this.bindButton(this.loadScenen, () => {
              director.loadScene("scene");
            });
          }); // [3]
        }

        startGameFun() {
          console.log("游戏正式开始");
        }

        endGameFun() {
          console.log("游戏结束");
        } // update (deltaTime: number) {
        //     // [4]
        // }


      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "inGame", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "mainGame", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "startGame", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "endGame", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "loadScenen", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));
      /**
       * [1] Class member could be defined like this.
       * [2] Use `property` decorator if your want the member to be serializable.
       * [3] Your initialization goes here.
       * [4] Your update function goes here.
       *
       * Learn more about scripting: https://docs.cocos.com/creator/3.0/manual/en/scripting/
       * Learn more about CCClass: https://docs.cocos.com/creator/3.0/manual/en/scripting/ccclass.html
       * Learn more about life-cycle callbacks: https://docs.cocos.com/creator/3.0/manual/en/scripting/life-cycle-callbacks.html
       */


      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=test.js.map