System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, ButtonComponent, instantiate, Component, _dec, _class, _temp, _crd, ccclass, property, SDKbaseView;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      ButtonComponent = _cc.ButtonComponent;
      instantiate = _cc.instantiate;
      Component = _cc.Component;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "43477Czk99Kkqr6dB58/VJE", "SDKbaseView", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("SDKbaseView", SDKbaseView = (_dec = ccclass('SDKbaseView'), _dec(_class = (_temp = class SDKbaseView extends Component {
        constructor(...args) {
          super(...args);

          _defineProperty(this, "_clickEnable", true);
        }

        // 控制能否点击的变量

        /**
        * 绑定按钮点击事件,永久监听
        * @param node 挂载了button组件的节点
        * @param callback 回调
        * @param opname 操作内容
        */
        bindButton(node, callback, ...parameters) {
          let btnComp = node.getComponent(ButtonComponent);

          if (!btnComp) {
            btnComp = node.addComponent(ButtonComponent);
            btnComp.transition = ButtonComponent.Transition.SCALE;
          }

          btnComp.zoomScale = 0.9;

          let btnCb = event => {
            if (!this._clickEnable) return;
            this._clickEnable = false;
            this.scheduleOnce(() => {
              this._clickEnable = true;
            }, 0.3);
            callback.call(this, ...parameters);
            TyqSdk.outMain();
          };

          node.on("click", btnCb, this);
        }
        /**
        * 绑定按钮点击事件(只监听一次)
        * @param node 挂载了button组件的节点
        * @param callback 回调
        * @param opname 操作内容
        */


        bindButtonOce(node, callback, opname) {
          let btnComp = node.getComponent(ButtonComponent);

          if (!btnComp) {
            btnComp = node.addComponent(ButtonComponent);
            btnComp.transition = ButtonComponent.Transition.SCALE;
          }

          btnComp.zoomScale = 0.9;

          let btnCb = event => {
            if (!this._clickEnable) return;
            this._clickEnable = false;
            this.scheduleOnce(() => {
              this._clickEnable = true;
            }, 0.3);
            callback.call(this, event);
            TyqSdk.outMain();
          };

          node.once("click", btnCb, this);
        }

        showUI(cPrefab, cNode, next) {
          let node = instantiate(cPrefab);
          node.parent = cNode;
          next && next(node.getComponent(node.name) ? node.getComponent(node.name) : node);
        }

      }, _temp)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=SDKbaseView.js.map