System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk", "./tyqToutiao"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, SDKbaseView, tyqSDK, Toutiao, _dec, _class, _crd, ccclass, property, sdk_shareVideo;

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOfToutiao(extras) {
    _reporterNs.report("Toutiao", "./tyqToutiao", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }, function (_tyqToutiao) {
      Toutiao = _tyqToutiao.Toutiao;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "40b458gNhdIIrhhWfDmARmN", "sdk_shareVideo", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("sdk_shareVideo", sdk_shareVideo = (_dec = ccclass('sdk_shareVideo'), _dec(_class = class sdk_shareVideo extends (_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView) {
        start() {
          this.bindButton(this.node, this.upLoad);
        }
        /**上传 */


        upLoad() {
          console.log("达人点击上传视频");
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).outMain();
          (_crd && Toutiao === void 0 ? (_reportPossibleCrUseOfToutiao({
            error: Error()
          }), Toutiao) : Toutiao).login().then(() => {
            console.log("登录");
            return (_crd && Toutiao === void 0 ? (_reportPossibleCrUseOfToutiao({
              error: Error()
            }), Toutiao) : Toutiao).getUserInfo();
          }).then(cres => {
            console.log("授权");
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).RecordCut(res => {
              console.log("分享视频返回值");
              console.log(res);
            }, this, cres);
          });
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=sdk_shareVideo.js.map