System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, Node, SpriteFrame, Sprite, tween, v3, tyqSDK, _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp, _crd, ccclass, property, tyq_boxItem;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      SpriteFrame = _cc.SpriteFrame;
      Sprite = _cc.Sprite;
      tween = _cc.tween;
      v3 = _cc.v3;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "086a9ARn9pIbIfQJsE2FfWK", "tyq_boxItem", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("tyq_boxItem", tyq_boxItem = (_dec = ccclass('tyq_boxItem'), _dec2 = property({
        type: SpriteFrame,
        tooltip: "宝箱打开的图片"
      }), _dec3 = property({
        type: Sprite,
        tooltip: "要替换图片的节点"
      }), _dec4 = property({
        type: Node,
        tooltip: "背景光"
      }), _dec5 = property({
        type: Node,
        tooltip: "奖励"
      }), _dec6 = property({
        type: SpriteFrame,
        tooltip: "体力和钻石的图片"
      }), _dec(_class = (_class2 = (_temp = class tyq_boxItem extends Component {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "openSp", _descriptor, this);

          _initializerDefineProperty(this, "baoxiang", _descriptor2, this);

          _initializerDefineProperty(this, "guang", _descriptor3, this);

          _initializerDefineProperty(this, "reward", _descriptor4, this);

          _initializerDefineProperty(this, "spList", _descriptor5, this);

          _defineProperty(this, "isWatch", false);
        }

        /**
         * 
         * @param type 是否是视频宝箱
         */
        init(type) {
          this.isWatch = type;

          if (!this.isWatch) {
            this.node.getChildByName("video").active = false;
          } // if (!taolu) {
          //     this.node.getChildByName("video")!.getComponent(SpriteComponent)!.color._set_a_unsafe(255);
          // }

        }
        /**获取是否是视频宝箱 */


        get watch() {
          return this.isWatch;
        }
        /**打开宝箱 */


        open() {
          this.baoxiang.spriteFrame = this.openSp;
          this.node.getChildByName("video").active = false;
          this.guang.active = true;
          tween(this.guang).by(2, {
            eulerAngles: v3(0, 0, 360)
          }).repeatForever().start();
          const num = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).RandomNumBoth(0, 1);
          this.reward.active = true;
          this.reward.getComponent(Sprite).spriteFrame = this.spList[num];

          if (num == 0) {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).Physical = 1;
          } else {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).Diamonds = 1;
          } //奖励逻辑请写在这里

        }
        /**变成普通宝箱 */


        changeType() {
          this.isWatch = false;
          this.node.getChildByName("video").active = false;
        } // update (deltaTime: number) {
        //     // Your update function goes here.
        // }


      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "openSp", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "baoxiang", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "guang", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "reward", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "spList", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_boxItem.js.map