System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, Node, LabelComponent, SpriteFrame, SpriteComponent, Texture2D, assetManager, tyqSDK, _dec, _class, _crd, ccclass, property, tyq_gameItem;

  function _reportPossibleCrUseOfgameInfo(extras) {
    _reporterNs.report("gameInfo", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      LabelComponent = _cc.LabelComponent;
      SpriteFrame = _cc.SpriteFrame;
      SpriteComponent = _cc.SpriteComponent;
      Texture2D = _cc.Texture2D;
      assetManager = _cc.assetManager;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9738cOExOVLV6+zJARVlKTL", "tyq_gameItem", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("tyq_gameItem",
      /**反正更多游戏面板的item */
      tyq_gameItem = (_dec = ccclass('tyq_gameItem'), _dec(_class = class tyq_gameItem extends Component {
        init(value) {
          this.node.getChildByName("gameName").getComponent(LabelComponent).string = value.gameName;
          this.node.getChildByName("playNum").getComponent(LabelComponent).string = value.gameTips;
          this.node.on(Node.EventType.TOUCH_END, () => {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).navigateToVideoView(value, "游戏盒子");
          }, this);
          if ((_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).gameList.length < 12) return;
          assetManager.loadRemote(value.gameImg, (err, spf) => {
            if (err) {
              console.log(err);
              return;
            }

            ;
            const sp = new SpriteFrame();
            const tex = new Texture2D();
            tex.image = spf;
            sp.texture = tex;
            this.node.getComponent(SpriteComponent).spriteFrame = sp;
          });
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_gameItem.js.map