System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, Sprite, SpriteFrame, instantiate, Label, tween, v3, SDKbaseView, tyqSDK, _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _temp, _crd, ccclass, property, TyqLuckDraw;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      Sprite = _cc.Sprite;
      SpriteFrame = _cc.SpriteFrame;
      instantiate = _cc.instantiate;
      Label = _cc.Label;
      tween = _cc.tween;
      v3 = _cc.v3;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "74fd4UMV85BrbQyPfVVlquR", "tyq_luckDraw", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("TyqLuckDraw", TyqLuckDraw = (_dec = ccclass('TyqLuckDraw'), _dec2 = property({
        type: SpriteFrame,
        tooltip: "轮换的图片，第一张是默认，第二张是选中"
      }), _dec3 = property({
        type: Node,
        tooltip: "抽奖的父节点"
      }), _dec4 = property({
        type: Node,
        tooltip: "关闭按钮"
      }), _dec5 = property({
        type: Node,
        tooltip: "抽一次"
      }), _dec6 = property({
        type: Node,
        tooltip: "看视频抽一次"
      }), _dec7 = property({
        type: Node,
        tooltip: "奖励节点"
      }), _dec(_class = (_class2 = (_temp = class TyqLuckDraw extends (_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView) {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "spList", _descriptor, this);

          _initializerDefineProperty(this, "layout", _descriptor2, this);

          _initializerDefineProperty(this, "close", _descriptor3, this);

          _initializerDefineProperty(this, "once", _descriptor4, this);

          _initializerDefineProperty(this, "videoOnce", _descriptor5, this);

          _initializerDefineProperty(this, "reward", _descriptor6, this);

          _defineProperty(this, "drawData", [{
            type: "phy",
            count: 2
          }, {
            type: "diam",
            count: 10
          }, {
            type: "null",
            count: 0
          }, {
            type: "phy",
            count: 5
          }, {
            type: "diam",
            count: 2
          }, {
            type: "phy",
            count: 3
          }, {
            type: "null",
            count: 0
          }, {
            type: "diam",
            count: 5
          }]);

          _defineProperty(this, "curIndex", 0);
        }

        start() {
          //关闭按钮
          this.bindButton(this.close, () => {
            this.node.destroy();
          });
          this.bindButton(this.once, this.starDraw); //直接抽

          this.bindButton(this.videoOnce, this.videoDraw); //看视频抽
          //生成奖励对应的数量

          for (let i = 1; i < this.drawData.length; i++) {
            if (this.drawData[i].count == 0) continue;
            const node = instantiate(this.layout.children[0].getChildByName("Label"));
            node.getComponent(Label).string = "x" + this.drawData[i].count;
            node.parent = this.layout.children[i];
          }

          var curTime = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getTimeStamp(true); //一天只能免费抽奖一次

          const last = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getItem("tyq_draw");

          if (!last) {
            //没有抽过奖
            this.videoOnce.active = false;
          } else if (last == curTime) {
            //今天抽过奖
            this.once.active = false;
          } else {
            //今天没抽过奖
            this.videoOnce.active = false;
          }

          this.node.setSiblingIndex(10);
        }
        /**开始抽奖 */


        starDraw() {
          //按钮隐藏
          this.close.active = false;
          this.videoOnce.active = false;
          this.once.active = false; //开始随机一个

          const num = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).RandomNumBoth(40, 50);
          console.log(num);
          console.log(this.curIndex);
          this.showDraw(this.curIndex, num);
          var data = new Date();
          const curTime = data.getFullYear().toString() + (data.getMonth() + 1).toString() + data.getDate().toString(); //精确到日期  

          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).setItem("tyq_draw", curTime);
        }
        /**转盘表现 */


        showDraw(curIndex, endIndex) {
          const index = curIndex % this.layout.children.length;
          this.curIndex = index;
          let lastIndex = index - 1;

          if (lastIndex < 0) {
            lastIndex = this.layout.children.length - 1;
          }

          this.layout.children[lastIndex].getComponent(Sprite).spriteFrame = this.spList[0];
          this.layout.children[index].getComponent(Sprite).spriteFrame = this.spList[1]; //达到极限

          if (curIndex == endIndex) {
            if (this.drawData[index].count == 0) {
              this.endReward();
              return;
            }

            ;
            this.showReward(index);
            return;
          }

          let delyTime = 0;

          if (curIndex < endIndex / 2) {
            delyTime = 0.25 - curIndex / endIndex;
          } else {
            delyTime = curIndex / endIndex - 0.75;
          }

          if (delyTime < 0) {
            delyTime = 0.02;
          }

          this.scheduleOnce(() => {
            curIndex++;
            this.showDraw(curIndex, endIndex);
          }, delyTime);
        }
        /**
         * 展示奖励
         */


        showReward(index) {
          this.reward.destroyAllChildren();
          const uiNode = instantiate(this.layout.children[index].getChildByName("ui"));
          uiNode.parent = this.reward;
          const labelNode = instantiate(this.layout.children[index].getChildByName("Label"));
          labelNode.parent = this.reward;
          labelNode.setPosition(0, -50, 0);
          this.reward.active = true;
          this.reward.setScale(0, 0, 0);
          tween(this.reward).to(0.5, {
            scale: v3(2, 2, 2)
          }).delay(1).call(() => {
            this.endReward();
          }).start();

          if (this.drawData[index].type == "phy") {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).Physical = this.drawData[index].count;
          } else {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).Diamonds = this.drawData[index].count;
          }
        }
        /**结束奖励 */


        endReward() {
          this.reward.active = false;
          this.close.active = true;
          this.videoOnce.active = true;
        }
        /**看视频抽奖 */


        videoDraw() {
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).showVideoAD("今日抽奖", () => {
            this.starDraw();
          });
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "spList", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return [];
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "layout", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "close", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "once", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "videoOnce", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "reward", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_luckDraw.js.map