System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyqToutiao", "./tyq-sdk", "./tyq-sdk-config"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, Label, Prefab, SDKbaseView, Toutiao, tyqSDK, tyqSDKConfig, _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _dec7, _dec8, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _descriptor6, _descriptor7, _class3, _temp, _crd, ccclass, property, tyq_main;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOfToutiao(extras) {
    _reporterNs.report("Toutiao", "./tyqToutiao", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDKConfig(extras) {
    _reporterNs.report("tyqSDKConfig", "./tyq-sdk-config", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      Label = _cc.Label;
      Prefab = _cc.Prefab;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqToutiao) {
      Toutiao = _tyqToutiao.Toutiao;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }, function (_tyqSdkConfig) {
      tyqSDKConfig = _tyqSdkConfig.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "02e68Sh/n9FL4Klbsqk10iT", "tyq_main", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("tyq_main", tyq_main = (_dec = ccclass('tyq_main'), _dec2 = property({
        type: Node,
        tooltip: "体力"
      }), _dec3 = property({
        type: Node,
        tooltip: "钻石"
      }), _dec4 = property({
        type: Node,
        tooltip: "更多游戏"
      }), _dec5 = property({
        type: Node,
        tooltip: "幸运抽奖"
      }), _dec6 = property({
        type: Node,
        tooltip: "关注"
      }), _dec7 = property({
        type: Node,
        tooltip: "内测福利"
      }), _dec8 = property({
        type: Prefab,
        tooltip: "vip面板"
      }), _dec(_class = (_class2 = (_temp = _class3 = class tyq_main extends (_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView) {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "physical", _descriptor, this);

          _initializerDefineProperty(this, "diamonds", _descriptor2, this);

          _initializerDefineProperty(this, "moreGame", _descriptor3, this);

          _initializerDefineProperty(this, "luckDraw", _descriptor4, this);

          _initializerDefineProperty(this, "follow", _descriptor5, this);

          _initializerDefineProperty(this, "welfare", _descriptor6, this);

          _initializerDefineProperty(this, "tyq_vipPanel", _descriptor7, this);
        }

        static getInstance() {
          if (!this._instance) {
            console.error("场景未初始化");
          } else {
            return this._instance;
          }
        }

        start() {
          tyq_main._instance = this; // //根据开关判断是否需要打开这些功能

          this.showMain();
          const phyAdd = this.physical.getChildByName("add");
          const dimAdd = this.diamonds.getChildByName("add");
          dimAdd.active = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getSwitchInfoByName("addPlus");
          phyAdd.active = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getSwitchInfoByName("addPlus"); //绑定按钮

          this.bindButton(this.moreGame, () => {
            //更多游戏
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).showMoreGameBoxPanel(true);
          });
          this.bindButton(this.follow, () => {
            //关注
            (_crd && Toutiao === void 0 ? (_reportPossibleCrUseOfToutiao({
              error: Error()
            }), Toutiao) : Toutiao).openAwemeUserProfile();
          });
          this.bindButton(this.luckDraw, () => {
            //幸运抽奖
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).showLuckDraw();
          });
          this.bindButton(this.welfare, () => {
            //内测
            this.showUI(this.tyq_vipPanel, this.node.parent);
          });
          this.bindButton(phyAdd, () => {
            //体力
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).showVideoAD("主页体力加号", () => {
              (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
                error: Error()
              }), tyqSDK) : tyqSDK).Physical = 1;
            });
          });
          this.bindButton(dimAdd, () => {
            //钻石
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).showVideoAD("主页钻石加号", () => {
              (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
                error: Error()
              }), tyqSDK) : tyqSDK).Diamonds = 1;
            });
          }); //开启增加体力倒计时

          this.upDataString();
          this.countDown();
        }
        /**倒计时 */


        countDown() {
          const phy = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).Physical;

          if (phy < 10) {
            var timer = 60 * (_crd && tyqSDKConfig === void 0 ? (_reportPossibleCrUseOftyqSDKConfig({
              error: Error()
            }), tyqSDKConfig) : tyqSDKConfig).recoverTime;
            this.physical.getChildByName("countDown").active = true;
            this.scheduleOnce(() => {
              (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
                error: Error()
              }), tyqSDK) : tyqSDK).Physical = 1;
              this.upDataString();
              this.countDown();
            }, 60 * (_crd && tyqSDKConfig === void 0 ? (_reportPossibleCrUseOftyqSDKConfig({
              error: Error()
            }), tyqSDKConfig) : tyqSDKConfig).recoverTime);
            this.schedule(() => {
              timer--;
              let min = Math.floor(timer / 60); //获取分钟，除以60取整数，得到整数分钟

              let secondTime = timer % 60; //获取秒数，秒数取佘，得到整数秒数

              this.physical.getChildByName("countDown").getComponent(Label).string = min.toString().padStart(2, '0') + ":" + secondTime.toString().padStart(2, '0');
            }, 1, 60 * (_crd && tyqSDKConfig === void 0 ? (_reportPossibleCrUseOftyqSDKConfig({
              error: Error()
            }), tyqSDKConfig) : tyqSDKConfig).recoverTime);
          } else {
            this.physical.getChildByName("countDown").active = false;
          }
        }
        /**改变体力 */


        changePhy() {
          const phy = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).Physical;

          if (phy > 10) {
            this.unscheduleAllCallbacks();
            this.physical.getChildByName("countDown").active = false;
          }

          this.upDataString();
        }

        upDataString() {
          this.physical.getChildByName("Label").getComponent(Label).string = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).Physical + "";
          this.diamonds.getChildByName("Label").getComponent(Label).string = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).Diamonds + "";
        }

        hideMain() {
          this.moreGame.active = false;
          this.luckDraw.active = false;
          this.follow.active = false;
          this.welfare.active = false;
        }

        showMain() {
          this.moreGame.active = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getSwitchInfoByName("moreGame");
          this.luckDraw.active = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getSwitchByName("luckDraw");
          this.follow.active = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getSwitchByName("follow");
          this.welfare.active = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getSwitchByName("welfare");
        } // onDestroy(){
        //     console.log("被销毁");
        // }
        // onDisable(){
        //     console.log("被隐藏");
        // }


      }, _defineProperty(_class3, "_instance", null), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "physical", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "diamonds", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "moreGame", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "luckDraw", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "follow", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor6 = _applyDecoratedDescriptor(_class2.prototype, "welfare", [_dec7], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor7 = _applyDecoratedDescriptor(_class2.prototype, "tyq_vipPanel", [_dec8], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_main.js.map