System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk", "./tyq_gameItem"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, Prefab, instantiate, SDKbaseView, tyqSDK, tyq_gameItem, _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp, _crd, ccclass, property, tyq_moreGamePanel;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyq_gameItem(extras) {
    _reporterNs.report("tyq_gameItem", "./tyq_gameItem", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      Prefab = _cc.Prefab;
      instantiate = _cc.instantiate;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }, function (_tyq_gameItem) {
      tyq_gameItem = _tyq_gameItem.tyq_gameItem;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "d0636hfg4lN+4A7/ppFpCZT", "tyq_moreGamePanel", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("tyq_moreGamePanel", tyq_moreGamePanel = (_dec = ccclass('tyq_moreGamePanel'), _dec2 = property({
        type: Node,
        tooltip: "今日最佳的layout"
      }), _dec3 = property({
        type: Node,
        tooltip: "编辑精选的layout"
      }), _dec4 = property({
        type: Node,
        tooltip: "返回"
      }), _dec5 = property({
        type: Prefab,
        tooltip: "游戏item预制体"
      }), _dec(_class = (_class2 = (_temp = class tyq_moreGamePanel extends (_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView) {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "layOut1", _descriptor, this);

          _initializerDefineProperty(this, "layOut2", _descriptor2, this);

          _initializerDefineProperty(this, "back", _descriptor3, this);

          _initializerDefineProperty(this, "tyq_gameItem", _descriptor4, this);
        }

        start() {
          let arry = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).gameList;
          arry.sort(this.randList);

          for (let i = 0; i < 6; i++) {
            const node = instantiate(this.tyq_gameItem);
            node.parent = this.layOut1;
            node.getComponent(_crd && tyq_gameItem === void 0 ? (_reportPossibleCrUseOftyq_gameItem({
              error: Error()
            }), tyq_gameItem) : tyq_gameItem).init(arry[i]);
          }

          if (arry.length < 9) return;

          for (let i = 6; i < arry.length; i++) {
            const node = instantiate(this.tyq_gameItem);
            node.parent = this.layOut2;
            node.getComponent(_crd && tyq_gameItem === void 0 ? (_reportPossibleCrUseOftyq_gameItem({
              error: Error()
            }), tyq_gameItem) : tyq_gameItem).init(arry[i]);
          }

          this.bindButton(this.back, this.backFun);
        }
        /**返回 */


        backFun() {
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).hideMoreGameBoxPanel();
        }
        /**随机数组 */


        randList() {
          return 0.5 - Math.random();
        }

        onEnable() {
          this.node.setSiblingIndex(this.node.parent.children.length - 1);
        }

      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "layOut1", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "layOut2", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "back", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "tyq_gameItem", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_moreGamePanel.js.map