System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../easyFramework/notifications", "../utils/LocalCache"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Notifications, LocalCache, _crd, ccclass, property, BaseData;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfNotifications(extras) {
    _reporterNs.report("Notifications", "../easyFramework/notifications", _context.meta, extras);
  }

  function _reportPossibleCrUseOfLocalCache(extras) {
    _reporterNs.report("LocalCache", "../utils/LocalCache", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
    }, function (_easyFrameworkNotifications) {
      Notifications = _easyFrameworkNotifications.Notifications;
    }, function (_utilsLocalCache) {
      LocalCache = _utilsLocalCache.LocalCache;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "2dc60QPZHFJD5GnCQ4TtHQa", "BaseData", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property; //基础数据结构

      BaseData = /*#__PURE__*/function () {
        function BaseData(cacheName) {
          _defineProperty(this, "dictCache", void 0);

          _defineProperty(this, "cacheName", void 0);

          this.cacheName = cacheName;
        } //重新开始


        var _proto = BaseData.prototype;

        _proto.resetCache = function resetCache() {} //复活
        ;

        _proto.reAlive = function reAlive() {}
        /**
          * 添加事件
          * @param {string} eKey     识别key
          * @param {object} eCall    回调函数
          * @param {object} self     识别对象
          */
        ;

        _proto.on = function on(eKey, eCall, self) {
          (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).on(eKey, eCall, self ? self : this);
        }
        /**
         * 通知事件
         * @param {string} eKey     识别key
         * @param {object} data     传值
         * @param {object} data2     传值
         */
        ;

        _proto.emit = function emit(eKey) {
          var _ref;

          for (var _len = arguments.length, parameters = new Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
            parameters[_key - 1] = arguments[_key];
          }

          var a = (_ref = _crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).emit.apply(_ref, [eKey].concat(parameters));

          if (a) {
            return a;
          }
        }
        /**
        * 注销某个事件
        * @param {string} eKey 识别key
        * @param {object} self 识别对象 
        */
        ;

        _proto.off = function off(eKey, self) {
          (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
            error: Error()
          }), Notifications) : Notifications).off(eKey, self ? self : this);
        };

        _proto.getCache = function getCache() {
          return (_crd && LocalCache === void 0 ? (_reportPossibleCrUseOfLocalCache({
            error: Error()
          }), LocalCache) : LocalCache).getItem(this.cacheName);
        }
        /**保存数据到缓存 */
        ;

        _proto.updateCache = function updateCache() {
          (_crd && LocalCache === void 0 ? (_reportPossibleCrUseOfLocalCache({
            error: Error()
          }), LocalCache) : LocalCache).setItem(this.cacheName, this.dictCache);
        } //根据id从数组中获取需要的配置
        ;

        _proto.getListCfgById = function getListCfgById(cfg, id) {
          for (var i = 0; i < cfg.length; i++) {
            if (cfg[i].ID == id) return cfg[i];
          }

          return null;
        };

        return BaseData;
      }();

      _export("default", BaseData);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=BaseData.js.map