System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./playMgr", "./levelMgr", "../easyFramework/notifications", "./GDef"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, Game, game, playerMgr, levelMgr, Notifications, GDef, _crd, GD;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfplayerMgr(extras) {
    _reporterNs.report("playerMgr", "./playMgr", _context.meta, extras);
  }

  function _reportPossibleCrUseOflevelMgr(extras) {
    _reporterNs.report("levelMgr", "./levelMgr", _context.meta, extras);
  }

  function _reportPossibleCrUseOfNotifications(extras) {
    _reporterNs.report("Notifications", "../easyFramework/notifications", _context.meta, extras);
  }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "./GDef", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      Game = _cc.Game;
      game = _cc.game;
    }, function (_playMgr) {
      playerMgr = _playMgr.default;
    }, function (_levelMgr) {
      levelMgr = _levelMgr.default;
    }, function (_easyFrameworkNotifications) {
      Notifications = _easyFrameworkNotifications.Notifications;
    }, function (_GDef) {
      GDef = _GDef.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9559fmyiY5CUZkXrQsgZPJX", "GD", undefined);

      //游戏世界数据层
      GD = /*#__PURE__*/function () {
        //玩家信息管理
        //关卡数据
        function GD() {
          _defineProperty(this, "playerMgr", void 0);

          _defineProperty(this, "levelMgr", void 0);

          this.playerMgr = new (_crd && playerMgr === void 0 ? (_reportPossibleCrUseOfplayerMgr({
            error: Error()
          }), playerMgr) : playerMgr)();
          this.levelMgr = new (_crd && levelMgr === void 0 ? (_reportPossibleCrUseOflevelMgr({
            error: Error()
          }), levelMgr) : levelMgr)();
        } // private cutFun = null;


        var _proto = GD.prototype;

        _proto.init = function init() {
          this.playerMgr.init(); //初始化玩家管理

          this.levelMgr.init(); //初始化关卡管理
          //监听切换后台

          game.on(Game.EVENT_HIDE, function () {
            game.pause(); //暂停游戏
          });
          game.on(Game.EVENT_SHOW, function () {
            game.resume(); //恢复游戏

            setTimeout(function () {
              (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                error: Error()
              }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                error: Error()
              }), GDef) : GDef).wdEvent.playBgm, true);
            }, 500);
          });
        };

        return GD;
      }();

      _export("default", new GD());

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=GD.js.map