System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, JsonAsset, resources, _crd, configTableMgr, ConfigTableMgr;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      JsonAsset = _cc.JsonAsset;
      resources = _cc.resources;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "a7e45gh5NFP9LcJDYWY2Ijl", "configTableMgr", undefined);

      /**
       * @description JSON表模块
       */
      configTableMgr = /*#__PURE__*/function () {
        function configTableMgr() {
          _defineProperty(this, "configTableMap", {});
        }

        var _proto = configTableMgr.prototype;

        ////////////////////////////
        // get、set访问器
        ///////////////////////////
        ////////////////////////////
        // 接口
        ///////////////////////////

        /**
         * @description 加载json文件夹
         * @param pathName
         */
        _proto.loadConfigTable = function loadConfigTable(pathName) {
          var _this = this;

          return new Promise(function (resolve, reject) {
            resources.loadDir(pathName, JsonAsset, function (err, resource) {
              if (err) {
                console.error('=====> @framework, 加载配置表失败: ', err);
                reject();
                return;
              }

              resource.forEach(function (jsonAsset) {
                _this.configTableMap[jsonAsset.name] = jsonAsset.json;
              });
              resolve();
            });
          });
        }
        /**
         * @description 获取json文件
         * @param jsonName
         */
        ;

        _proto.getConfigTableItem = function getConfigTableItem(jsonName) {
          var item = this.configTableMap[jsonName];

          if (item) {
            return item;
          } else {
            console.error("=====> @framework, \u83B7\u53D6\u914D\u7F6E\u8868\u6587\u4EF6\u5931\u8D25, \u6587\u4EF6:" + jsonName + ".json \u4E0D\u5B58\u5728");
            return null;
          }
        }
        /**
         * 获取自选关卡数据
         */
        ;

        _proto.getSelfCreatorData = function getSelfCreatorData() {
          return this.getConfigTableItem('selfCreator');
        };

        return configTableMgr;
      }();

      _defineProperty(configTableMgr, "_instance", new configTableMgr());

      _export("ConfigTableMgr", ConfigTableMgr = configTableMgr._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=configTableMgr.js.map