System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./BaseData", "./global", "../utils/UtilsMath", "./DataManager"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, BaseData, global, MathRandom, DataManager, _crd, ccclass, property, CONFIGS, levelMgr;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _reportPossibleCrUseOfBaseData(extras) {
    _reporterNs.report("BaseData", "./BaseData", _context.meta, extras);
  }

  function _reportPossibleCrUseOfglobal(extras) {
    _reporterNs.report("global", "./global", _context.meta, extras);
  }

  function _reportPossibleCrUseOfMathRandom(extras) {
    _reporterNs.report("MathRandom", "../utils/UtilsMath", _context.meta, extras);
  }

  function _reportPossibleCrUseOfDataManager(extras) {
    _reporterNs.report("DataManager", "./DataManager", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
    }, function (_BaseData) {
      BaseData = _BaseData.default;
    }, function (_global) {
      global = _global.default;
    }, function (_utilsUtilsMath) {
      MathRandom = _utilsUtilsMath.MathRandom;
    }, function (_DataManager) {
      DataManager = _DataManager.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9ef54T7iuBEk67+/wSZV9bV", "levelMgr", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;
      CONFIGS = {
        cacheName: "levelInfo"
      };

      //关卡数据管理
      levelMgr = /*#__PURE__*/function (_ref) {
        _inheritsLoose(levelMgr, _ref);

        //字段可以直接读,改动最好通过接口

        /**后台数据 */

        /**游戏状态 */
        function levelMgr() {
          return _ref.call(this, CONFIGS.cacheName) || this;
        }

        var _proto = levelMgr.prototype;

        _proto.init = function init() {
          var info = this.getCache();

          if (info) {
            this.dictCache = info;
          } else {
            this.dataInit();
          }
        }
        /**数据初始化 */
        ;

        _proto.dataInit = function dataInit() {
          this.dictCache = {
            Checkpoint: 1
          };
          this.updateCache();
        }
        /**
         * 获取当前关卡
         */
        ;

        /**
         * 当前关卡+1
         */
        _proto.setCheckpoint = function setCheckpoint() {
          this.dictCache.Checkpoint++;
          this.updateCache();
        }
        /**获取关卡数据
         * @param ID 如果传进关卡ID，则指定加载某一关
         */
        ;

        _proto.getCheckJson = function getCheckJson(ID) {
          var num = 0;

          if (ID) {
            num = ID;
          } else {
            num = this.dictCache.Checkpoint; //超过关卡上限，随机一关出来

            if (num > (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).levelCount) {
              num = (_crd && MathRandom === void 0 ? (_reportPossibleCrUseOfMathRandom({
                error: Error()
              }), MathRandom) : MathRandom).getInstance().RandomNumBoth(1, (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
                error: Error()
              }), global) : global).levelCount);
            }
          }

          var lv = "level" + num;
          return (_crd && DataManager === void 0 ? (_reportPossibleCrUseOfDataManager({
            error: Error()
          }), DataManager) : DataManager).getTable(lv);
        };

        _createClass(levelMgr, [{
          key: "checkPoint",
          get: function get() {
            return this.dictCache.Checkpoint;
          }
        }]);

        return levelMgr;
      }(_crd && BaseData === void 0 ? (_reportPossibleCrUseOfBaseData({
        error: Error()
      }), BaseData) : BaseData);

      _export("default", levelMgr);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=levelMgr.js.map