System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./BaseData", "../config/global", "./GDef"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Game, game, BaseData, global, GDef, _crd, ccclass, property, CONFIGS, playerMgr;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfBaseData(extras) {
    _reporterNs.report("BaseData", "./BaseData", _context.meta, extras);
  }

  function _reportPossibleCrUseOfglobal(extras) {
    _reporterNs.report("global", "../config/global", _context.meta, extras);
  }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "./GDef", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Game = _cc.Game;
      game = _cc.game;
    }, function (_BaseData) {
      BaseData = _BaseData.default;
    }, function (_configGlobal) {
      global = _configGlobal.default;
    }, function (_GDef) {
      GDef = _GDef.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9ff29IR9JhE9Jf5JEZl9VCz", "playMgr", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;
      CONFIGS = {
        cacheName: "playerInfo"
      };

      //玩家数据管理
      playerMgr = /*#__PURE__*/function (_ref) {
        _inheritsLoose(playerMgr, _ref);

        //字段可以直接读,改动最好通过接口

        /**后台数据 */

        /**游戏状态 */
        //是否正在倒计时
        function playerMgr() {
          var _this;

          _this = _ref.call(this, CONFIGS.cacheName) || this;

          _defineProperty(_assertThisInitialized(_this), "isCutDown", false);

          return _this;
        }

        var _proto = playerMgr.prototype;

        _proto.init = function init() {
          var _this2 = this;

          console.log("初始化玩家管理.........");
          var info = this.getCache();

          if (info) {
            this.dictCache = info;
            var date = new Date();
            var curTime = date.getTime();
            this.afterTime(curTime);
            this.afterTimeVip(curTime);
          } else {
            this.dataInit();
          }

          this.gameState = (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
            error: Error()
          }), global) : global).GAME_STATE.GAME_WAIT; //游戏变成等待

          game.on(Game.EVENT_HIDE, function () {
            _this2.setTime();
          });
        }
        /**数据初始化 */
        ;

        _proto.dataInit = function dataInit() {
          var date = new Date();
          var curTime = date.getTime();
          this.dictCache = {
            coin: 0,
            physical: (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).Physical,
            curTime: curTime,
            player: "",
            shock: 1,
            voice: 1,
            vipCount: 0,
            vipStarTime: 0,
            specialModelCount_1: 0,
            specialModelCount_2: 0,
            popupState: 1
          };
          this.updateCache();
        }
        /**
         * 经过多少时间(体力)
         */
        ;

        _proto.afterTime = function afterTime(curTime) {
          var count = Number(this.dictCache.physical);
          if (count >= (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
            error: Error()
          }), global) : global).Physical) return;
          var lastTime = Number(this.dictCache.curTime);
          var minute = 0;
          minute = (curTime - lastTime) / 1000 / 60 / (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
            error: Error()
          }), global) : global).physicalTime;
          var num = Math.floor(minute);
          this.dictCache.curTime = lastTime; //当前时间是上一次退出的时间，用于区分倒计时

          if (this.dictCache.curTime) {
            var time = (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).physicalTime * 60 - Math.floor((curTime - this.dictCache.curTime) / 1000 % ((_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).physicalTime * 60));

            if (time > 0) {
              this.recoveryPhysical(time);
            }
          }

          if (num > 0) {
            this.setPhysical(num * (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).physicalCount);
          }
        }
        /**经过多少时间 (vip时间)*/
        ;

        _proto.afterTimeVip = function afterTimeVip(curTime) {
          var _this3 = this;

          if (!this.dictCache.vipStarTime || this.dictCache.vipStarTime == 0) return;
          var lastTime = Number(this.dictCache.vipStarTime);
          var disTime = (curTime - lastTime) / 1000 / 60; //1440为24小时的分钟

          if (disTime >= 1440) {
            //超过24小时
            this.vipCount = 0;
            this.dictCache.vipStarTime = 0;
          } else {
            //没到24小时
            var surTime = 1440 - disTime;
            setTimeout(function () {
              _this3.vipCount = 0;
              _this3.dictCache.vipStarTime = 0;
            }, surTime * 1000 * 60);
          }
        }
        /**
        * 恢复体力
        */
        ;

        _proto.recoveryPhysical = function recoveryPhysical(time) {
          var _this4 = this;

          if (this.isCutDown) return;
          this.isCutDown = true; //如果体力小于最大值，每5分钟增加一个 ，并储存一个计时开始的时间

          if (!this.dictCache.curTime) {
            this.setTime();
          }

          setTimeout(function () {
            _this4.isCutDown = false;
            var count = _this4.physical;

            if (count < (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).Physical) {
              _this4.setPhysical((_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
                error: Error()
              }), global) : global).physicalCount);
            }
          }, time ? time * 1000 : (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
            error: Error()
          }), global) : global).physicalTime * 60 * 1000);
        }
        /**
          * 设置体力
          * @param num 获得的体力数
          * @param exceed 是否能够超越最大值
          */
        ;

        _proto.setPhysical = function setPhysical(num, exceed) {
          if (exceed === void 0) {
            exceed = false;
          }

          var count = this.physical;
          count += num;
          this.dictCache.curTime = null; //可以超越

          if (exceed) {
            this.dictCache.physical = count;
          } else {
            if (count > (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).Physical) {
              this.dictCache.physical = (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
                error: Error()
              }), global) : global).Physical;
            } else {
              this.dictCache.physical = count;
              this.recoveryPhysical();
            }
          }

          this.emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
            error: Error()
          }), GDef) : GDef).wdEvent.upPhysical);
          this.updateCache();
        }
        /**
           * 设置时间
           */
        ;

        _proto.setTime = function setTime() {
          if (!this.dictCache.curTime) {
            var date = new Date();
            var curTime = date.getTime();
            this.dictCache.curTime = curTime;
          }

          this.updateCache();
        }
        /**
            * 获取上一次损耗体力开始时间
            */
        ;

        _proto.getTime = function getTime() {
          if (!this.dictCache.curTime) {
            this.setTime();
          }

          return this.dictCache.curTime;
        } // /**判断需要弹出的弹窗类型 */
        // popupType(){
        //     if(GD.playerMgr.dictCache.popupState == 1){
        //         GD.playerMgr.dictCache.popupState = 2
        //     }else{
        //         GD.playerMgr.dictCache.popupState = 1
        //     }
        //     this.updateCache();
        // }

        /**
         * 设置游戏状态
         * 0:等待,1:继续,2:结束
         */
        ;

        _proto.setGameState = function setGameState(state) {
          this.gameState = state;
        }
        /**
         * 获取游戏状态
         * 0:等待,1:继续,2:结束
         */
        ;

        _proto.getGameState = function getGameState() {
          return this.gameState;
        }
        /**获取金币 */
        ;

        /**设置金币 */
        _proto.setcoin = function setcoin(num) {
          this.dictCache.coin = num + Number(this.dictCache.coin);
          this.updateCache();
          this.emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
            error: Error()
          }), GDef) : GDef).wdEvent.updateCoin);
        }
        /**
           * 消耗体力
           */
        ;

        _createClass(playerMgr, [{
          key: "coin",
          get: function get() {
            return this.dictCache.coin;
          }
          /**获取体力 */

        }, {
          key: "physical",
          get: function get() {
            return this.dictCache.physical;
          },
          set: function set(num) {
            var count = this.physical;
            count += num;
            this.dictCache.physical = count;

            if (count >= (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).Physical) {
              this.dictCache.curTime = null;
            } else {
              this.recoveryPhysical();
            }

            this.updateCache();
          }
        }, {
          key: "player",
          get: function get() {
            return this.dictCache.player;
          }
          /**设置声音 */
          ,
          set: function set(str) {
            this.dictCache.player = str;
            this.updateCache();
          }
        }, {
          key: "Voice",
          get:
          /**获取声音设置状态 */
          function get() {
            var bool = this.dictCache.voice == 1 ? true : false;
            return bool;
          }
          /**设置震动 */
          ,
          set: function set(bool) {
            if (bool) {
              this.dictCache.voice = 1;
            } else {
              this.dictCache.voice = 2;
            }

            this.emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
              error: Error()
            }), GDef) : GDef).wdEvent.voiceSet, this.Voice);
            this.updateCache();
          }
        }, {
          key: "Shock",
          get:
          /**获取震动设置状态 */
          function get() {
            var bool = this.dictCache.shock == 1 ? true : false;
            return bool;
          }
          /**获得当前观看vip视频的次数 */
          ,
          set: function set(bool) {
            if (bool) {
              this.dictCache.shock = 1;
            } else {
              this.dictCache.shock = 2;
            }

            this.updateCache();
          }
        }, {
          key: "vipCount",
          get: function get() {
            if (!this.dictCache.vipCount) {
              this.dictCache.vipCount = 0;
            }

            return this.dictCache.vipCount;
          }
          /**s设置观看次数 */
          ,
          set: function set(num) {
            if (!this.dictCache.vipCount) {
              this.dictCache.vipCount = 0;
            }

            this.dictCache.vipCount = num; //如果当前vip次数达到，则倒计时24小时

            if (this.dictCache.vipCount >= (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
              error: Error()
            }), global) : global).vipCount) {
              var date = new Date();
              var curTime = date.getTime();
              this.dictCache.vipStarTime = curTime; //体力值满

              if (this.dictCache.physical < (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
                error: Error()
              }), global) : global).Physical) {
                this.dictCache.physical = (_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
                  error: Error()
                }), global) : global).Physical;
                this.emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                  error: Error()
                }), GDef) : GDef).wdEvent.upPhysical);
              }
            }
          }
          /**获得地狱模式当前观看视频的次数 */

        }, {
          key: "specialModelCount_1",
          get: function get() {
            if (!this.dictCache.specialModelCount_1) {
              this.dictCache.specialModelCount_1 = 0;
            }

            return this.dictCache.specialModelCount_1;
          }
          /**设置地狱模式观看次数 */
          ,
          set: function set(num) {
            if (!this.dictCache.specialModelCount_1) {
              this.dictCache.specialModelCount_1 = 0;
            }

            this.dictCache.specialModelCount_1 = num;
          }
          /**获得天选模式当前观看视频的次数 */

        }, {
          key: "specialModelCount_2",
          get: function get() {
            if (!this.dictCache.specialModelCount_2) {
              this.dictCache.specialModelCount_2 = 0;
            }

            return this.dictCache.specialModelCount_2;
          }
          /**设置天选模式观看次数 */
          ,
          set: function set(num) {
            if (!this.dictCache.specialModelCount_2) {
              this.dictCache.specialModelCount_2 = 0;
            }

            this.dictCache.specialModelCount_2 = num;
          }
        }]);

        return playerMgr;
      }(_crd && BaseData === void 0 ? (_reportPossibleCrUseOfBaseData({
        error: Error()
      }), BaseData) : BaseData);

      _export("default", playerMgr);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=playMgr.js.map