System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../../../config/GDef", "../../notifications"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, director, find, sys, UITransform, view, GDef, Notifications, _crd, toutiao, Toutiao;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "../../../config/GDef", _context.meta, extras);
  }

  function _reportPossibleCrUseOfNotifications(extras) {
    _reporterNs.report("Notifications", "../../notifications", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      director = _cc.director;
      find = _cc.find;
      sys = _cc.sys;
      UITransform = _cc.UITransform;
      view = _cc.view;
    }, function (_configGDef) {
      GDef = _configGDef.default;
    }, function (_notifications) {
      Notifications = _notifications.Notifications;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "aef7eEvgR9JvJCrF+Rhkkwf", "toutiao", undefined);

      // import { NetworkMgr } from "../../network/networkMgr";
      sys.BYTEDANCE_GAME = sys.Platform.BYTEDANCE_MINI_GAME; // TODO: 录制视频成功，并且打印出视频所在位置，分享视频的时候显示shareVideo: fail parse share info fail; 把功能移植到特工上面是可以分享的，不知道是不是录制内容问题

      toutiao = /*#__PURE__*/function () {
        ////////////////////////////
        // 构造器
        ///////////////////////////
        function toutiao() {
          _defineProperty(this, "systemInfo", null);

          _defineProperty(this, "bannerAd", null);

          _defineProperty(this, "rewardedVideoAd", null);

          _defineProperty(this, "GameRecorderManager", null);

          _defineProperty(this, "ContactButton", null);

          _defineProperty(this, "MoregameButton", null);

          _defineProperty(this, "startListener", null);

          _defineProperty(this, "resumeListener", null);

          _defineProperty(this, "pauseListener", null);

          _defineProperty(this, "stopListener", null);

          _defineProperty(this, "errorListener", null);

          _defineProperty(this, "interrupBeginListener", null);

          _defineProperty(this, "interrupEndListener", null);

          _defineProperty(this, "_bannerAdUnitId", '2rd7pitt3bf2aopjp3');

          _defineProperty(this, "_bannerAdRefreshTimeOutId", 0);

          _defineProperty(this, "_rewardedVideoAdUnitId", '1wiwq4d83j1d2qbhop');

          _defineProperty(this, "_closeRewardVideoListener", null);

          _defineProperty(this, "__interstitialAdUnitId", "bckgi35eea68309f20");

          _defineProperty(this, "interstitialAd", null);

          if (window.tt) {
            this.getSystemInfoSync(); // this.registerRecordScreenEvent();
            //this.handle();
          }
        } ////////////////////////////
        // 登录模块
        ///////////////////////////


        var _proto = toutiao.prototype;

        _proto.toutiaoLogin = function toutiaoLogin() {
          var _this = this;

          return new Promise(function (resolve, reject) {
            _this.getSystemInfoSync();

            var loginData = {
              code: '',
              anonymousCode: '',
              name: null,
              photo: null
            };

            _this.login().then(function (res) {
              loginData.code = res.code;
              loginData.anonymousCode = res.anonymousCode;

              if (res.isLogin) {
                _this.getUserInfo().then(function (data) {
                  loginData.name = data.userInfo.nickName;
                  loginData.photo = data.userInfo.avatarUrl;
                  resolve(loginData);
                })["catch"](function () {
                  reject(loginData);
                });
              } else {
                resolve(loginData);
              }
            })["catch"](function () {
              reject();
            });
          });
        }
        /**
         * @description 获取临时登录凭证
         */
        ;

        _proto.login = function login() {
          return new Promise(function (resolve, reject) {
            tt.login({
              /** 未登录时，是否强制调起登录框 */
              force: false,
              success: function success(res) {
                console.log("login\u8C03\u7528\u6210\u529F" + res.code + " " + res.anonymousCode);
                resolve(res);
              },
              fail: function fail(res) {
                console.log('login调用失败');
                reject();
              }
            });
          });
        }
        /**
         * @description 获取已登录用户的基本信息或特殊信息
         * @tips 本 API 依赖于login，请确保调用前已经调用了该API
         */
        ;

        _proto.getUserInfo = function getUserInfo() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          return new Promise(function (resolve, reject) {
            tt.getUserInfo({
              /** 是否需要返回敏感数据 */
              withCredentials: true,
              success: function success(res) {
                console.log("getUserInfo\u8C03\u7528\u6210\u529F" + res.userInfo);
                resolve(res);
              },
              fail: function fail(res) {
                console.log('getUserInfo调用失败: ', res);
                reject();
              }
            });
          });
        } ////////////////////////////
        // banner广告
        ///////////////////////////

        /**
         * @description 显示banner广告
         * @param refreshTime 自动刷新时间，默认10秒，0为不刷新；
         */
        ;

        _proto.showBannerAd = function showBannerAd(refreshTime) {
          var _this2 = this;

          if (refreshTime === void 0) {
            refreshTime = 30;
          }

          if (sys.platform != sys.BYTEDANCE_GAME) return;

          if (!toutiao.isSupportedAPI(tt.createBannerAd)) {
            console.log('不支持banner广告');
            return;
          }

          this.hideBannerAd();
          this.createBannerAd();
          this.bannerAd.onLoad(function () {
            console.log('=====> @framework, banner广告加载成功');

            _this2.bannerAd.show().then(function (args) {
              console.log("----> =====> @framework, banner广告 show 成功", args);
            })["catch"](function (args) {
              console.log("----> =====> @framework, banner广告 show 失败", args);
            }); // 移除setTimeout


            if (_this2._bannerAdRefreshTimeOutId != 0) {
              clearTimeout(_this2._bannerAdRefreshTimeOutId);
              _this2._bannerAdRefreshTimeOutId = 0;
            } // 延时刷新banner


            if (refreshTime > 0) {
              _this2._bannerAdRefreshTimeOutId = setTimeout(function () {
                if (_this2.bannerAd) _this2.showBannerAd(refreshTime);
              }, refreshTime * 1000);
            }
          });
        }
        /**
         * @description 隐藏banner广告
         */
        ;

        _proto.hideBannerAd = function hideBannerAd() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          console.log("----> hideBannerAd", this.bannerAd);

          if (this.bannerAd) {
            this.bannerAd.hide();
            this.bannerAd.destroy();
            this.bannerAd = null;
          }
        }
        /**
         * @description 创建banner广告
         * @tips 每个广告实例只会与一条固定的广告素材绑定。开发者如果想要展示另一条广告，需要创建一个新的bannerAd实例。
         * Banner广告一般的比例为16:9，最小宽度是128（设备像素），最大宽度是208（设备像素）。开发者可以在这之间自由指定广告宽度。广告组件会自动等比例缩放素材。
         */
        ;

        _proto.createBannerAd = function createBannerAd() {
          var _this3 = this;

          if (sys.platform != sys.BYTEDANCE_GAME) return;
          console.log('this.createBannerAd');

          if (this.bannerAd) {
            return;
          }

          var targetBannerAdWidth = 128;
          this.bannerAd = tt.createBannerAd({
            // 广告单元 id
            adUnitId: this._bannerAdUnitId,
            style: {
              // 根据系统约定尺寸计算出广告高度
              top: this.systemInfo.windowHeight - targetBannerAdWidth / 16 * 9,
              // left: (this.systemInfo.windowWidth - targetBannerAdWidth) / 2,
              width: targetBannerAdWidth
            }
          });
          this.bannerAd.onError(function (res) {
            console.log('=====> @framework, banner广告加载失败：', res);
          });
          this.bannerAd.onResize(function (res) {
            if (_this3.bannerAd && targetBannerAdWidth !== res.width) {
              _this3.bannerAd.style.top = _this3.systemInfo.windowHeight - res.height;
              _this3.bannerAd.style.left = (_this3.systemInfo.windowWidth - res.width) / 2;
              _this3.bannerAd.style.width = res.width;
            }
          });
        }
        /**
        	 * 调起抖音看广告视频
        	 * @param str 为什么看视频
        	 */
        ;

        _proto.showRewardVideoAd = function showRewardVideoAd(str) {
          var _this4 = this;

          if (sys.platform != sys.Platform.BYTEDANCE_MINI_GAME) {
            console.log("未进入看广告");
            return;
          }

          return new Promise(function (resolve, reject) {
            _this4.createRewardedVideoAd().then(function () {
              _this4.rewardedVideoAd.show().then(function () {//加载成功
              })["catch"](function (err) {
                tt.uma.trackEvent("touchVideo", {
                  source: str,
                  state: "广告组件出现问题"
                });

                _this4.rewardedVideoAd.load().then(function () {
                  _this4.rewardedVideoAd.show();
                });
              });
            }, function (err) {
              console.log('=====> @framework, 奖励视频对象为不存在');
              tt.uma.trackEvent("touchVideo", {
                source: str,
                state: err ? "加载广告失败-字节的原因" : "失败-用户版本不支持视频广告"
              });
              reject();
              return null;
            }); //关闭视频回调。


            var closeListener = function closeListener(res) {
              //用户完整的看完了视频
              if (res.isEnded) {
                resolve(); //看完广告获得薯片
                // this.getChips(0);

                tt.uma.trackEvent("touchVideo", {
                  source: str,
                  state: "成功"
                });
              } else {
                reject();
                (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                  error: Error()
                }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                  error: Error()
                }), GDef) : GDef).wdEvent.VideoErr, "失败");
                tt.uma.trackEvent("touchVideo", {
                  source: str,
                  state: "失败-用户提前关闭"
                });
              }

              _this4.closeRewardVideo();

              _this4.rewardedVideoAd.offClose(closeListener);
            }; //当用户点击了 Video 广告上的关闭按钮时，会触发 close 事件的监听器。


            _this4.rewardedVideoAd.onClose(closeListener);

            var errorListener = function errorListener(res) {
              console.log('=====> @framework, 加载奖励视频错误：', res);
              var msg = "观看广告失败：未知原因";

              switch (res.errCode) {
                case 1000:
                  msg = "观看广告失败：后端错误调用失败";
                  break;

                case 1001:
                  msg = "观看广告失败：参数错误";
                  break;

                case 1002:
                  msg = "观看广告失败：广告单元无效";
                  break;

                case 1003:
                  msg = "观看广告失败：内部错误";
                  break;

                case 1004:
                  msg = "观看广告失败：无适合的广告";
                  break;

                case 1005:
                  msg = "观看广告失败：广告组件审核中";
                  break;

                case 1006:
                  msg = "观看广告失败：广告组件被驳回";
                  break;

                case 1007:
                  msg = "观看广告失败：广告能力被禁用";
                  break;

                case 1008:
                  msg = "观看广告失败：广告单元已关闭";
                  break;

                case 20002:
                  msg = "观看广告失败：不支持 banner 广告 API";
                  break;

                case 120002:
                  msg = "观看广告失败：今日观看广告次数已达上限";
                  break;

                default:
                  break;
              }

              reject();
              (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                error: Error()
              }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                error: Error()
              }), GDef) : GDef).wdEvent.VideoErr, msg);
              tt.uma.trackEvent("touchVideo", {
                source: str,
                state: "失败" + msg
              });

              _this4.rewardedVideoAd.offError(errorListener);
            };

            _this4.rewardedVideoAd.onError(errorListener);
          });
        }
        /**
        * @description 创建视频广告单例（小游戏端是全局单例）
        * @tips 全局只有一个videoAd实例，重复创建没有用
        */
        ;

        _proto.createRewardedVideoAd = function createRewardedVideoAd() {
          var _this5 = this;

          return new Promise(function (resolve, reject) {
            if (!tt.createRewardedVideoAd) {
              console.log('=====> @framework, 当前客户端版本过低，无法使用奖励视频功能，请升级到最新客户端版本后重试');
              reject();
              return;
            }

            if (_this5.rewardedVideoAd) {
              resolve();
              return;
            }

            _this5.rewardedVideoAd = tt.createRewardedVideoAd({
              adUnitId: _this5._rewardedVideoAdUnitId
            });

            _this5.rewardedVideoAd.load().then(function () {
              resolve();
            }, function () {
              console.log("加载失败");
            })["catch"](function (err) {
              console.log("----> =====> @framework, 奖励视频加载失败", err);
              reject(err);
            });
          });
        };

        _proto.closeRewardVideo = function closeRewardVideo() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;

          if (this._closeRewardVideoListener) {
            this._closeRewardVideoListener();
          }
        } ////////////////////////////
        // 分享
        ///////////////////////////

        /**
         * @description 主动拉起转发界面
         * @param _title 转发标题，不传则默认使用当前小游戏的名称。
         * @param _imageUrl 转发显示图片的链接，可以是网络图片路径或本地图片文件路径或相对代码包根目录的图片文件路径，显示图片长宽比推荐 5:4
         * @param _query 查询字符串，必须是 key1=val1&key2=val2 的格式。从这条转发消息进入后，可通过 tt.getLaunchOptionSync() 或 tt.onShow() 获取启动参数中的 query。
         */
        ;

        _proto.shareAppMessage = function shareAppMessage(_title, _videoUrl, _extra, _query) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          return new Promise(function (resolve, reject) {
            tt.shareAppMessage({
              // article	发布图文内容
              // video	发布视频内容
              // token	口令分享，生成一串特定的字符串文本，仅头条APP支持
              channel: 'video',
              //
              title: _title,
              // imageUrl: _videoUrl,
              //query: _query,

              /** 附加信息 */
              extra: {
                videoTag: _extra[0],
                videoPath: _videoUrl,
                hashtag_list: _extra,
                videoTopics: _extra,
                withVideoId: true
              },
              success: function success(res) {
                resolve(res);
              },
              fail: function fail(e) {
                console.error(e);
                reject();
              }
            });
          });
        }
        /**跳转视频播放页 
         * @param videoId 传入的视频id
        */
        ;

        _proto.navigateToVideoView = function navigateToVideoView(videoId) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          return new Promise(function (resolve, reject) {
            tt.navigateToVideoView({
              videoId: videoId,
              success: function success(res) {
                resolve(res.videoId);
                /* res结构： {errMsg: string } */
              },
              fail: function fail(e) {
                if (e.errCode === 1006) {
                  tt.showToast({
                    title: "something wrong with your network"
                  });
                }

                reject();
              }
            });
          });
        }
        /**获取视频点赞数，封面图 
         * @param videoId 传入的视频id//可以是数组形式
        */
        ;

        _proto.request = function request(videoId) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          return new Promise(function (resolve, reject) {
            tt.request({
              url: "https://gate.snssdk.com/developer/api/get_video_info",
              method: "POST",
              data: {
                alias_ids: [videoId]
              },
              success: function success(res) {
                resolve(res);
              },
              fail: function fail(e) {
                reject();
              }
            });
          });
        }
        /**
         * @description 注册GameRecorderManager
         */
        ;

        _proto.registerRecordScreenEvent = function registerRecordScreenEvent() {
          var _this6 = this;

          if (!toutiao.isSupportedAPI(tt.getGameRecorderManager)) {
            console.log('=====> @framework,当前客户端版过低，无法使用奖励视频功能，请升级到最新客户端版本后重试');
            return;
          }

          this.GameRecorderManager = tt.getGameRecorderManager(); // 监听录屏开始事件

          this.GameRecorderManager.onStart(function (res) {
            if (_this6.startListener) {
              _this6.startListener();
            }
          }); // 监听录屏继续事件

          this.GameRecorderManager.onResume(function () {
            if (_this6.resumeListener) {
              _this6.resumeListener();
            }
          }); // 监听录屏暂停事件

          this.GameRecorderManager.onPause(function () {
            if (_this6.pauseListener) {
              _this6.pauseListener();
            }
          }); // 监听录屏结束事件。可以通过 onStop 接口监听录屏结束事件，获得录屏地址

          this.GameRecorderManager.onStop(function (res) {
            if (_this6.stopListener) {
              _this6.stopListener(res.videoPath, res);
            }
          }); // 监听录屏错误事件

          this.GameRecorderManager.onError(function (res) {
            console.log('=====> @framework,录屏错误：', res.errMsg);

            if (_this6.errorListener) {
              _this6.errorListener();
            }
          }); // 监听录屏中断开始

          this.GameRecorderManager.onInterruptionBegin(function () {
            if (_this6.interrupBeginListener) {
              _this6.interrupBeginListener();
            }
          }); // 监听录屏中断结束

          this.GameRecorderManager.onInterruptionEnd(function () {
            if (_this6.interrupEndListener) {
              _this6.interrupEndListener();
            }
          }); //监听用户分享

          tt.onShareAppMessage(function (res) {
            return {
              templateId: "",
              success: function success() {// console.log('转发发布器已调起');
              },
              fail: function fail() {// console.log('转发发布器调起失败');
                //console.log(res);
              }
            };
          });
        }
        /**
         * @description 开始录屏
         * @param _duration 录屏的时长，单位 s，必须大于3s，最大值 120（2 分钟）
         * @param callback 录制开始事件回调
         */
        ;

        _proto.startRecordScreen = function startRecordScreen(_duration, callback) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          this.startListener = callback;
          this.GameRecorderManager.start({
            duration: _duration
          });
        }
        /**
         * @description 暂停录屏
         */
        ;

        _proto.pauseRecordScreen = function pauseRecordScreen(callback) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          this.pauseListener = callback;
          this.GameRecorderManager.pause();
        };

        _proto.resumeRecordScreen = function resumeRecordScreen(callback) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          this.resumeListener = callback;
          this.GameRecorderManager.resume();
        }
        /**
         * @description 暂停录屏
         * @param callback
         */
        ;

        _proto.stopRecordScreen = function stopRecordScreen(callback) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          this.stopListener = callback;
          this.GameRecorderManager.stop();
        } ////////////////////////////
        // 其他能力
        ///////////////////////////

        /**
         * @description 检查用户当前的 session 状态是否有效。
         * @tips 只有成功调用 tt.login 才会生成 session，checkSession 才会进入 success 回调当用户退出登录会清除 session
         */
        ;

        _proto.checkSession = function checkSession() {
          return new Promise(function (resolve, reject) {
            tt.checkSession({
              success: function success() {
                resolve();
                console.log('session未过期');
              },
              fail: function fail() {
                reject();
                console.log('session已过期，需要重新登录');
              }
            });
          });
        }
        /**显示客服管理按钮 */
        ;

        _proto.showContactButton = function showContactButton(url, _success, _fail) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          var pixelSize = director.getWinSizeInPixels();
          var Framesize = view.getFrameSize();
          var scalX = Framesize.width / pixelSize.width;
          var scalY = Framesize.height / pixelSize.height;
          console.log(Framesize);

          if (!this.ContactButton) {
            this.ContactButton = tt.createContactButton({
              type: "image",
              //
              image: url,

              /** 附加信息 */
              style: {
                left: Framesize.width / 2 - 193 * scalX / 2,
                top: Framesize.height / 2 + 100,
                width: 193 * scalX,
                height: 82 * scalY,
                borderWidth: 0,
                borderRadius: 10
              },
              success: function success(res) {
                console.log("客服创建成功");

                if (_success) {
                  _success();
                }
              },
              fail: function fail(e) {
                console.log("客服创建失败");

                if (_fail) {
                  _fail();
                }
              }
            });
          } else {
            this.ContactButton.show();
          }
        }
        /**客服按钮隐藏 */
        ;

        _proto.hideContactButton = function hideContactButton() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          if (!this.ContactButton) return;
          this.ContactButton.hide();
        }
        /**添加更多游戏的按钮 */
        ;

        _proto.createMoreGamesButton = function createMoreGamesButton(_success2, _fail2) {
          var _this7 = this;

          if (sys.platform != sys.BYTEDANCE_GAME) return;
          var node = find("Canvas").getComponent(UITransform);
          var width = node.width;
          var height = node.height;

          if (!this.ContactButton) {
            this.ContactButton = tt.createMoreGamesButton({
              type: "text",
              image: "",

              /** 附加信息 */
              style: {
                left: 20,
                top: 40,
                width: 150,
                height: 40,
                lineHeight: 40
              },
              actionType: "box",
              appLaunchOptions: [{
                appId: "ttXXXXXX",
                query: "foo=bar&baz=qux",
                extraData: {}
              } // {...}
              ],
              onNavigateToMiniGameBox: function onNavigateToMiniGameBox(res) {
                console.log("跳转到小游戏盒子", res);
              },
              success: function success(res) {
                console.log("更多游戏创建成功");

                _this7.ContactButton.show();

                if (_success2) {
                  _success2();
                }
              },
              fail: function fail(e) {
                console.log("更多游戏创建失败");
                console.log(e);

                if (_fail2) {
                  _fail2();
                }
              }
            });
          }
        }
        /**
         * @description 获取用户已经授权过的配置。结果中只会包含小程序向用户请求过的权限
         */
        ;

        _proto.getSetting = function getSetting() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          return new Promise(function (resolve, reject) {
            tt.getSetting({
              success: function success(res) {
                resolve(res.authSetting);
              },
              fail: function fail() {
                reject();
                console.log('session已过期，需要重新登录');
              }
            });
          });
        }
        /**调用方法会提前向用户发出授权请求。该方法不会调用对应接口，只会弹框咨询用户是否授权或者获取用户信息。如果用户之前有授权，该接口直接返回成功，不会跟用户产生交互 */
        ;

        _proto.authorize = function authorize() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          return new Promise(function (resolve, reject) {
            tt.authorize({
              authorize: 'scope.userInfo',
              success: function success(res) {
                resolve(res.authSetting);
              },
              fail: function fail() {
                reject();
                console.log('session已过期，需要重新登录');
              }
            });
          });
        }
        /**
         * @description 返回小游戏启动参数(好友邀请中获取query)
         */
        ;

        _proto.getLaunchOptionsSync = function getLaunchOptionsSync() {
          return tt.getLaunchOptionsSync();
        }
        /**
         *	打开设置页面，返回用户设置过的授权结果。
         */
        ;

        _proto.openSetting = function openSetting() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          return new Promise(function (resolve, reject) {
            tt.openSetting({
              success: function success(res) {
                resolve(res);
              },
              fail: function fail(res) {
                reject();
              }
            });
          });
        };

        ////////////////////////////
        // 震动
        ///////////////////////////

        /**
         * 使手机发生较长时间的振动。
         * @param callback 回调 (isSuccess, res)
         */
        _proto.vibrateLong = function vibrateLong(callback) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.vibrateLong({
            success: function success(res) {
              if (callback) callback(true, res);
            },
            fail: function fail(res) {
              if (callback) callback(false, res);
            }
          });
        };

        /**
         * 使手机发生较短时间的振动
         * @param cb 回调 (isSuccess, res)
         */
        _proto.vibrateShort = function vibrateShort(cb) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.vibrateShort({
            success: function success(res) {
              if (cb) cb(true, res);
            },
            fail: function fail(res) {
              if (cb) cb(false, res);
            }
          });
        };

        ////////////////////////////
        // 通用
        ///////////////////////////

        /**
         * @description 获取系统信息
         */
        _proto.getSystemInfoSync = function getSystemInfoSync() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;

          try {
            this.systemInfo = tt.getSystemInfoSync();
            console.log('this.systemInfo', this.systemInfo);
          } catch (e) {
            console.log('获取系统信息失败');
          }
        }
        /**
         * @description 是否支持改API
         * @param api
         */
        ;

        toutiao.isSupportedAPI = function isSupportedAPI(api) {
          return !!api;
        }
        /**
         * 	关闭小程序
         * @param 成功回调
         */
        ;

        _proto.exitMiniProgram = function exitMiniProgram(cb) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.exitMiniProgram({
            success: function success(res) {
              if (cb) cb(true, res);
            },
            fail: function fail(res) {
              if (cb) cb(false, res);
            }
          });
        };

        /**
         * 显示灰色背景的消息提示框
         * @param title 内容
         * @param duration 提示框停留时间，单位ms
         * @param cb 成功后回调
         */
        _proto.showToast = function showToast(title, duration, cb) {
          if (duration === void 0) {
            duration = 3000;
          }

          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.showToast({
            title: title,
            duration: duration,
            success: function success() {
              if (cb) cb();
            }
          });
        };

        /**
         * 获取系统信息
         * @param callback 成功后回调
         */
        _proto.getSystemInfo = function getSystemInfo(callback) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.getSystemInfo({
            success: function success(res) {
              if (callback) callback(res);
            }
          });
        };

        /**监听用户点击右上角菜单中的“转发”按钮时触发的事件
         * Tip： 该方法可以监听用户通过右上角菜单中触发的分享操作，在不同宿主端具体的操作会有所差别，在抖音中包括分享和拍抖音，在头条包括分享和发头条，以此类推。
        	Tip： 该方法的实际调用链路为
        
        	开发者注册此事件后
        	用户点击小游戏菜单中的分享或者拍抖音等按钮
        	自动调用开发者通过 tt.onShareAppMessage 定义的函数，并传入带有 channel 参数的对象，执行得到该函数的返回对象，
        	接着调用 tt.shareAppMessage ，将上一步返回的对象传入其中，拉起分享。
        	Tip：该方法可以用于监听用户在小游戏右上角菜单中的分享操作，开发者可以监听此事件并自定义分享行为。
         */
        _proto.onShareAppMessage = function onShareAppMessage(callback) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.onShareAppMessage(function (res) {
            // console.log(res);
            if (callback) callback(res);
          });
        }
        /**
         * 
         * @param time 生成最后几秒的视频
         * @param videoPath 视频地址，在结束录频时会返回，传入这里
         */
        ;

        _proto.clipVideo = function clipVideo(time, videoPath, callback) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          var recorder = this.GameRecorderManager;
          recorder.clipVideo({
            path: videoPath,
            timeRange: [time, 0],
            success: function success(res) {
              //如果成功，并且有回调
              if (callback) {
                callback(res);
              } // console.log(res.videoPath); // 生成最后time秒的视频

            },
            fail: function fail(e) {
              console.error(e);
            }
          });
        }
        /**
         * 显示分享按钮
         */
        ;

        _proto.showShareMenu = function showShareMenu() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.showShareMenu({
            success: function success(res) {
              console.log("已成功显示转发按钮");
            },
            fail: function fail(err) {
              console.log("showShareMenu 调用失败", err.errMsg);
            },
            complete: function complete(res) {
              console.log("showShareMenu 调用完成");
            }
          });
        }
        /**
         * 新的登录接口 获取code
         */
        ;

        _proto.TTLogin = function TTLogin(cb, _fail3) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.login({
            /** 未登录时，是否强制调起登录框 */
            force: true,
            success: function success(res) {
              if (cb) {
                cb(res);
              }
            },
            fail: function fail(res) {
              if (_fail3) {
                _fail3(res);
              }
            }
          });
        }
        /**
         * 获取用户敏感信息
         */
        ;

        _proto.TTGetUserInfo = function TTGetUserInfo(cb, _fail4) {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.getUserInfo({
            withCredentials: true,
            //获取用户敏感信息
            success: function success(res) {
              cb(res);
            },
            fail: function fail(res) {
              if (_fail4) {
                _fail4(res);
              }
            }
          });
        } // /**
        //  * 获得薯片
        //  * @param type 类型 1是分享 0是看视频
        //  */
        // public getChips(type: number) {
        // 	if (sys.platform != sys.BYTEDANCE_GAME) return;
        // 	// if (LocalCache.getItem("openid") && LocalCache.getItem("unionid") && LocalCache.getItem("nickName")) {
        // 	// 	let option = {
        // 	// 		openid: LocalCache.getItem("openid"),
        // 	// 		unionid: LocalCache.getItem("unionid"),
        // 	// 		score: 1,
        // 	// 		source: type
        // 	// 	}
        // 	// 	NetworkMgr.xhrPost("updateRanking.php", option, (res) => {
        // 	// 		if (res) {
        // 	// 			console.log(res);
        // 	// 			if (res.code == 0) {
        // 	// 				Notifications.emit(GDef.wdEvent.chipsEffects);
        // 	// 			}
        // 	// 		}
        // 	// 	})
        // 	// }
        // }
        ;

        _proto.showMoreGamesModal = function showMoreGamesModal() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.setMoreGamesInfo({
            appLaunchOptions: [{
              appId: "tta930df8d360b7e6d",
              // query: "gameName=假如学生爱拼拼图&pos=" + pos,
              query: "foo=bar&baz=qux",
              extraData: {}
            }, {
              appId: "tt7d820b3fe2b95842",
              // query: "gameName=赛几美食街&pos=" + pos,
              query: "foo=bar&baz=qux",
              extraData: {}
            }, {
              appId: "ttcf37b98a500cd748",
              // query: "gameName=赛几探险记&pos=" + pos,
              query: "foo=bar&baz=qux",
              extraData: {}
            }, {
              appId: "ttefcd997070f6f7bc",
              // query: "gameName=烧脑吧赛几&pos=" + pos,
              query: "foo=bar&baz=qux",
              extraData: {}
            }]
          });
          tt.showMoreGamesModal({
            appLaunchOptions: [{
              appId: "tta930df8d360b7e6d",
              // query: "gameName=假如学生爱拼拼图&pos=" + pos,
              query: "foo=bar&baz=qux",
              extraData: {}
            }, {
              appId: "tt7d820b3fe2b95842",
              // query: "gameName=赛几美食街&pos=" + pos,
              query: "foo=bar&baz=qux",
              extraData: {}
            }, {
              appId: "ttcf37b98a500cd748",
              // query: "gameName=赛几探险记&pos=" + pos,
              query: "foo=bar&baz=qux",
              extraData: {}
            }, {
              appId: "ttefcd997070f6f7bc",
              // query: "gameName=烧脑吧赛几&pos=" + pos,
              query: "foo=bar&baz=qux",
              extraData: {}
            }],
            success: function success(res) {
              console.log('success', res.errMsg);
            },
            fail: function fail(res) {
              console.log('fail', res.errMsg);
            }
          }); // tt.onNavigateToMiniProgram(function (res) {
          // 	console.log("open other games", res);
          // 	if (res.errCode != 2) {
          // 		// adLogic.reportAnalytics('clickMoreSuccess', {
          // 		//   name: pos,
          // 		//   errcode: res.errCode,
          // 		// });
          // 	}
          // })
        }
        /**返回抖音APP的名字 */
        ;

        _proto.returnAppName = function returnAppName() {
          console.log(this.systemInfo);

          if (!this.systemInfo) {
            return "";
          } else {
            return this.systemInfo.appName;
          } // return ""

        }
        /**
         * 关注抖音号
         */
        ;

        _proto.openAwemeUserProfile = function openAwemeUserProfile() {
          if (sys.platform != sys.BYTEDANCE_GAME) return;
          tt.openAwemeUserProfile();
        }
        /**创建插屏广告 */
        ;

        _proto.creatorInterstitialAd = function creatorInterstitialAd() {
          var _this8 = this;

          return new Promise(function (resolve, reject) {
            if (!tt.createInterstitialAd) {
              console.log("不支持插屏广告");
              reject();
              return;
            }

            if (_this8.interstitialAd) {
              console.log("插屏广告已经创建");
              resolve();
              return;
            }

            _this8.interstitialAd = tt.createInterstitialAd({
              adUnitId: _this8.__interstitialAdUnitId
            });

            _this8.interstitialAd.load().then(function () {
              resolve();
            }, function (err) {
              console.log("插屏广告出错啦");
              console.log(err);
            })["catch"](function (err) {
              console.log("插屏广告出错");
              console.log(err);
              reject();
            });
          });
        }
        /**
         * 展示插屏广告
         */
        ;

        _proto.showInterstitialAd = function showInterstitialAd() {
          var _this9 = this;

          if (sys.platform != sys.BYTEDANCE_GAME) return;
          console.log("插屏广告");
          this.creatorInterstitialAd().then(function () {
            _this9.interstitialAd.show().then(function () {
              console.log("插屏广告显示成功");
            })["catch"](function (err) {
              console.log(err);
              console.log("插屏广告显示失败"); //失败就再请求一次

              _this9.interstitialAd.load().then(function () {
                _this9.interstitialAd.show();
              });
            });
          });
        };

        _createClass(toutiao, [{
          key: "bannerAdUnitId",
          set: ////////////////////////////
          // 类成员
          ///////////////////////////

          /** 系统信息 */

          /** banner广告对象 */

          /** 奖励视频广告对象 */

          /** 全局唯一的录屏管理器 */

          /**客服按钮对象 */

          /**更多游戏按钮 */

          /** 录屏开始事件 */

          /** 监听录屏继续事件 */

          /** 录屏暂停事件 */

          /**  录屏结束事件 */

          /**  录屏错误事件 */

          /** 录屏中断开始事件 */

          /** 录屏中断结束事件 */

          /** banner广告id */

          /** 奖励视频广告id */

          /**插屏广告ID */

          /**插屏广告AD实例 */
          ////////////////////////////
          // get、set访问器
          ///////////////////////////
          function set(adUnitId) {
            this._bannerAdUnitId = adUnitId;
          }
        }, {
          key: "rewardedVideoAdUnitId",
          set: function set(adUnitId) {
            this._rewardedVideoAdUnitId = adUnitId;
          }
        }, {
          key: "closeRewardVideoListener",
          set: function set(cb) {
            this._closeRewardVideoListener = cb;
          }
        }, {
          key: "TTSystemInfo",
          get: function get() {
            return this.systemInfo;
          }
        }]);

        return toutiao;
      }();

      _defineProperty(toutiao, "_instance", new toutiao());

      _export("Toutiao", Toutiao = toutiao._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=toutiao.js.map