System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../../../config/GDef", "../../notifications"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, GDef, Notifications, _crd, vivo, Vivo;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "../../../config/GDef", _context.meta, extras);
  }

  function _reportPossibleCrUseOfNotifications(extras) {
    _reporterNs.report("Notifications", "../../notifications", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_configGDef) {
      GDef = _configGDef.default;
    }, function (_notifications) {
      Notifications = _notifications.Notifications;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "2c00dM4yelLy7vjii6Lc8G+", "Vivo", undefined);

      vivo = /*#__PURE__*/function () {
        function vivo() {
          _defineProperty(this, "videoAd", void 0);

          _defineProperty(this, "bannerAd", void 0);

          _defineProperty(this, "interstitialAd", void 0);

          _defineProperty(this, "nativeAd", void 0);

          _defineProperty(this, "videoPosId", '');

          _defineProperty(this, "bannerPosId", '');

          _defineProperty(this, "interstitialPosId", '');

          _defineProperty(this, "nativePosId", '');

          this.videoPosId = 'c3e164d1780f495e8be503a4ca81507e';
          this.bannerPosId = 'eded52d1915a4ca69c47e98b1fd9da9b';
          this.interstitialPosId = '894ac24050704fe0b6dd6218ac1f3e05';
          this.nativePosId = '2ccc025845d94d75b34a4acc2e173d60';
        } //获取系统信息的同步版本


        var _proto = vivo.prototype;

        //设置屏幕是否常量
        _proto.setKeepScreenOn = function setKeepScreenOn(bol) {
          qg.setKeepScreenOn({
            keepSrceenOn: bol,
            success: function success() {
              console.log('设置屏幕常亮成功');
            },
            fail: function fail() {},
            complete: function complete() {}
          });
        } //登录授权
        ;

        _proto.authorize_code = function authorize_code() {
          return new Promise(function (resolve, reject) {
            qg.authorize({
              type: "code",
              success: function success(data) {
                resolve(data);
              },
              fail: function fail(data, code) {
                reject(data);
              }
            });
          });
        } // 旧版本获取token
        ;

        _proto.authorize_token = function authorize_token() {
          return new Promise(function (resolve, reject) {
            qg.authorize({
              type: "token",
              success: function success(obj) {
                resolve(obj);
              },
              fail: function fail(data, code) {
                reject(data);
              }
            });
          });
        } // 获取授权信息 
        ;

        _proto.getProfile = function getProfile(_token) {
          return new Promise(function (resolve, reject) {
            qg.getProfile({
              token: _token,
              success: function success(data) {
                resolve(data);
              },
              fail: function fail(data, code) {
                reject(data);
              }
            });
          });
        }
        /*
        *  qg.exitApplication()
        *  退出游戏，同步方法
        */
        ;

        _proto.exitApplication = function exitApplication(cb) {
          qg.exitApplication();
        }
        /**
         * 使手机发生较长时间的振动。
         * @param callback 回调 (isSuccess, res)
         */
        ;

        _proto.vibrateLong = function vibrateLong(callback) {
          qg.vibrateLong();

          if (callback) {
            callback();
          }
        };

        /**
         * 使手机发生较短时间的振动
         * 
         */
        _proto.vibrateShort = function vibrateShort(cb) {
          qg.vibrateShort();

          if (cb) {
            cb();
          }
        };

        //=============================广告
        //播放激励视频
        _proto.showRewardVideoAd = function showRewardVideoAd(next) {
          var _this = this;

          if (this.systemInfo.platformVersionCode < 1041) return next && next(false);
          if (!qg.createRewardedVideoAd) return next && next(false);

          if (this.videoAd) {} else {
            this.videoAd = {
              adObj: null,
              isInVideo: false,
              callBack: null
            };
            this.videoAd.adObj = qg.createRewardedVideoAd({
              posId: this.videoPosId
            });
            this.videoAd.adObj.onError(function (err) {
              _this.videoAd.isInVideo = false;
              _this.videoAd.callBack && _this.videoAd.callBack(false); // Emitter.getInstance().emit("showADTip", '频繁观看广告，请稍后再试!');

              console.log("视频广告创建失败");

              switch (err.errCode) {
                case -3:
                  console.log("激励广告加载失败---调用太频繁", JSON.stringify(err));
                  (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                    error: Error()
                  }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                    error: Error()
                  }), GDef) : GDef).wdEvent.VideoErr, "激励广告加载失败");
                  break;

                case -4:
                  console.log("激励广告加载失败--- 一分钟内不能重复加载", JSON.stringify(err));
                  (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                    error: Error()
                  }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                    error: Error()
                  }), GDef) : GDef).wdEvent.VideoErr, "激励广告加载失败");
                  break;

                case 30008:
                  // 当前启动来源不支持激励视频广告，请选择其他激励策略
                  break;

                default:
                  console.log("激励广告展示失败", err);
                  (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                    error: Error()
                  }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                    error: Error()
                  }), GDef) : GDef).wdEvent.VideoErr, "激励广告展示失败");
                  break;
              }
            });
            this.videoAd.adObj.onLoad(function () {
              var adshow = _this.videoAd.adObj.show();

              adshow && adshow.then(function () {
                // 捕捉show失败的错误
                console.log("激励视频广告显示成功"); // if (AudioMgr.isOpen) {
                //     AudioMgr.pause();
                // }

                _this.videoAd.isInVideo = true;
              })["catch"](function (err) {
                console.log("激励视频广告显示失败", err);
                _this.videoAd.isInVideo = false;
                _this.videoAd.callBack && _this.videoAd.callBack(false); // Emitter.getInstance().emit("showADTip", '频繁观看广告，请稍后再试!');
              });
            });
            this.videoAd.adObj.onClose(function (res) {
              _this.videoAd.isInVideo = false;
              console.log('onClose!', res);

              if (res && res["isEnded"]) {
                _this.videoAd.callBack && _this.videoAd.callBack(true);
              } else {
                // Emitter.getInstance().emit("showADTip", '提前关闭视频不能得到奖励哦！');
                _this.videoAd.callBack && _this.videoAd.callBack(false);
                (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                  error: Error()
                }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                  error: Error()
                }), GDef) : GDef).wdEvent.VideoErr, "观看广告失败");
              } // if (AudioMgr.isOpen) {
              //     AudioMgr.resume();
              // }


              _this.videoAd.callBack = null; // this.rewardedVideoAd.offClose();
            });
          }

          this.videoAd.isInVideo = true;
          this.videoAd.callBack = next;
          var adLoad = this.videoAd.adObj.load(); //第一次调用 可能会报-3  广告能正常展示就可以忽略
          // 捕捉load失败的错误

          adLoad && adLoad.then(function () {
            console.log("激励视频广告加载成功");
            _this.videoAd.isInVideo = true;
          })["catch"](function (err) {
            _this.videoAd.isInVideo = false;
            console.log("激励视频广告加载失败", err); // Emitter.getInstance().emit("showADTip", '频繁观看广告，请稍后再试!');

            _this.videoAd.callBack && _this.videoAd.callBack(false);
          });
        } //------
        ;

        _proto.showBannerAd = function showBannerAd() {
          var _this2 = this;

          if (this.systemInfo.platformVersionCode < 1041) return;
          if (this.bannerAd) return;
          console.log('显示banner广告3');

          var doBannerShow = function doBannerShow() {
            var adshow = _this2.bannerAd.show();

            adshow && adshow.then(function () {
              console.log("banner广告展示成功");
            })["catch"](function (err) {
              switch (err.code) {
                case 30003:
                  console.log("新用户7天内不能曝光Banner，请将手机时间调整为7天后，退出游戏重新进入");
                  break;

                case 30009:
                  console.log("10秒内调用广告次数超过1次，10秒后再调用");
                  break;

                case 30002:
                  console.log("加载广告失败，重新加载广告");
                  break;

                default:
                  console.log("banner广告展示失败");
                  console.log(JSON.stringify(err));
                  break;
              }
            });
          };

          this.bannerAd = qg.createBannerAd({
            posId: this.bannerPosId,
            style: {}
          });
          console.log('创建banner广告第一步', this.bannerAd);
          this.bannerAd.onSize(function (res) {
            console.log('banner onResize', res); // gl.bannerSize = {
            //     width: res.width,
            //     height: (res.width / 16 * 9),
            //     winHeight: this.systemInfo.screenHeight
            // };
            // this.bannerAd.style.left = (this.systemInfo.screenWidth - res.width) / 2;
            // this.bannerAd.style.top = this.systemInfo.screenHeight - (res.width / 16 * 9);
          });
          this.bannerAd.onLoad(function () {
            _this2.bannerAd.offLoad && _this2.bannerAd.offLoad();
            console.log("banner 广告加载成功 ...");
            doBannerShow();
          });
          this.bannerAd.onError(function (err) {
            _this2.bannerAd.offError && _this2.bannerAd.offError();
            console.log("banner 广告创建失败 ...", err);
          });
          this.bannerAd.onClose(function (err) {
            _this2.bannerAd.offClose();

            console.log("onClose 广告创建 ...", err);
          });
        };

        _proto.hideBannerAd = function hideBannerAd() {
          var _this3 = this;

          if (!this.bannerAd) {
            return;
          }

          var addestroy = this.bannerAd.destroy(); // 调用then和catch之前需要对show的结果做下判空处理，防止出错（如果没有判空，在平台版本为1052以及以下的手机上将会出现错误）

          addestroy && addestroy.then(function () {
            console.log("banner广告销毁成功");

            _this3.bannerAd.offLoad();

            _this3.bannerAd.offError();

            _this3.bannerAd.offSize();
          })["catch"](function (err) {
            console.log("banner广告销毁失败", err);
          });
        } //-------
        //显示插屏广告
        ;

        _proto.showInterstitialAd = function showInterstitialAd(next) {
          var _this4 = this;

          if (this.systemInfo.platformVersionCode < 1031) return next && next(false);
          if (this.interstitialAd) return;

          var doShow = function doShow() {
            var adShow = _this4.interstitialAd.show(); // 调用then和catch之前需要对show的结果做下判空处理，防止出错（如果没有判空，在平台版本为1052以及以下的手机上将会出现错误）


            adShow && adShow.then(function () {
              console.log("插屏广告展示成功");
              next && next();
            })["catch"](function (err) {
              _this4.interstitialAd = null;

              switch (err.code) {
                case 30003:
                  console.log("新用户7天内不能曝光Banner，请将手机时间调整为7天后，退出游戏重新进入");
                  break;

                case 30009:
                  console.log("10秒内调用广告次数超过1次，10秒后再调用");
                  break;

                case 30002:
                  console.log("load广告失败，重新加载广告");
                  break;

                case 30000:
                  break;

                default:
                  console.log("插屏广告展示失败");
                  console.log(err);
                  break;
              }
            });
          };

          this.interstitialAd = qg.createInterstitialAd({
            posId: this.interstitialPosId
          });
          this.interstitialAd.onLoad(function () {
            console.log('加载插屏广告成功');
            doShow();
          }, function () {
            console.log('加载插屏广告失败');
            _this4.interstitialAd = null;
          });
          this.interstitialAd.onError(function (err) {
            console.log("插屏广告创建失败 ...", err);
            _this4.interstitialAd = null;
          });
          this.interstitialAd.onClose(function () {
            console.log("插屏 关闭 ...");
            _this4.interstitialAd && _this4.interstitialAd.offClose();
            _this4.interstitialAd = null;
          });
        } //----------
        //创建原生广告
        ;

        _proto.createNativeAd = function createNativeAd(next) {
          if (this.systemInfo.platformVersionCode < 1053) return next && next(false);
          this.nativeAd = qg.createNativeAd({
            posId: this.nativePosId
          });
          console.log("原生广告原生广告", this.nativeAd);
          this.nativeAd.onLoad(function (res) {
            if (res && res.adList) {
              console.log("原生广告", res);
              next && next(res.adList[0]);
            } else {
              next && next(null);
            }
          });
          this.nativeAd.onError(function (res) {
            console.log('原生广告加载失败', res);
            next && next();
          });
          var adLoad = this.nativeAd.load();
          adLoad && adLoad.then(function () {
            console.log("原生广告加载成功");
          })["catch"](function (err) {
            console.log('原生广告加载失败', JSON.stringify(err));
            next && next();
          });
        };

        _proto.clickNativeAd = function clickNativeAd(adId) {
          this.nativeAd.reportAdClick({
            adId: adId
          });
        } // 检查登录信息 5分钟后token 失效
        ;

        _proto.getSetting = function getSetting(cbOK, cbFail) {
          if (cbFail === void 0) {
            cbFail = null;
          }
        };

        _createClass(vivo, [{
          key: "systemInfo",
          get: function get() {
            return qg.getSystemInfoSync();
          }
        }]);

        return vivo;
      }();

      _defineProperty(vivo, "_instance", new vivo());

      _export("Vivo", Vivo = vivo._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=Vivo.js.map