System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, Node, LabelComponent, SpriteFrame, SpriteComponent, Texture2D, assetManager, tyqSDK, _dec, _class, _crd, ccclass, property, tyq_gameItem;

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _reportPossibleCrUseOfgameInfo(extras) {
    _reporterNs.report("gameInfo", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      LabelComponent = _cc.LabelComponent;
      SpriteFrame = _cc.SpriteFrame;
      SpriteComponent = _cc.SpriteComponent;
      Texture2D = _cc.Texture2D;
      assetManager = _cc.assetManager;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "9738cOExOVLV6+zJARVlKTL", "tyq_gameItem", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("tyq_gameItem",
      /**反正更多游戏面板的item */
      tyq_gameItem = (_dec = ccclass('tyq_gameItem'), _dec(_class = /*#__PURE__*/function (_Component) {
        _inheritsLoose(tyq_gameItem, _Component);

        function tyq_gameItem() {
          return _Component.apply(this, arguments) || this;
        }

        var _proto = tyq_gameItem.prototype;

        _proto.init = function init(value) {
          var _this = this;

          this.node.getChildByName("gameName").getComponent(LabelComponent).string = value.gameName;
          this.node.getChildByName("playNum").getComponent(LabelComponent).string = value.gameTips;
          this.node.on(Node.EventType.TOUCH_END, function () {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).navigateToVideoView(value, "游戏盒子");
          }, this);
          if ((_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).gameList.length < 12) return;
          assetManager.loadRemote(value.gameImg, function (err, spf) {
            if (err) {
              console.log(err);
              return;
            }

            ;
            var sp = new SpriteFrame();
            var tex = new Texture2D();
            tex.image = spf;
            sp.texture = tex;
            _this.node.getComponent(SpriteComponent).spriteFrame = sp;
          });
        };

        return tyq_gameItem;
      }(Component)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_gameItem.js.map