System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, SpriteFrame, Texture2D, SpriteComponent, assetManager, SDKbaseView, tyqSDK, _dec, _class, _crd, ccclass, property, tyq_gameItemMini;

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOfgameInfo(extras) {
    _reporterNs.report("gameInfo", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      SpriteFrame = _cc.SpriteFrame;
      Texture2D = _cc.Texture2D;
      SpriteComponent = _cc.SpriteComponent;
      assetManager = _cc.assetManager;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "60c70Rd3ElNQKfCk6Ccw86C", "tyq_gameItemMini", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("tyq_gameItemMini", tyq_gameItemMini = (_dec = ccclass('tyq_gameItemMini'), _dec(_class = /*#__PURE__*/function (_ref) {
        _inheritsLoose(tyq_gameItemMini, _ref);

        function tyq_gameItemMini() {
          return _ref.apply(this, arguments) || this;
        }

        var _proto = tyq_gameItemMini.prototype;

        _proto.init = function init(from, value) {
          var _this = this;

          // if (TyqSdk.gameList.length < 12) return;
          assetManager.loadRemote(value.gameImg, function (err, spf) {
            if (err) {
              console.log(err);
              return;
            }

            ;
            var sp = new SpriteFrame();
            var tex = new Texture2D();
            tex.image = spf;
            sp.texture = tex;
            _this.node.getComponent(SpriteComponent).spriteFrame = sp;
          });
          this.bindButton(this.node, function () {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).navigateToVideoView(value, from);
          });
        };

        return tyq_gameItemMini;
      }(_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_gameItemMini.js.map