System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk", "./tyq_boxItem"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, Prefab, ButtonComponent, SDKbaseView, tyqSDK, tyq_boxItem, _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp, _crd, ccclass, property, tyq_luckyBox;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyq_boxItem(extras) {
    _reporterNs.report("tyq_boxItem", "./tyq_boxItem", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      Prefab = _cc.Prefab;
      ButtonComponent = _cc.ButtonComponent;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }, function (_tyq_boxItem) {
      tyq_boxItem = _tyq_boxItem.tyq_boxItem;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "e8bb4pboYpADYo39uGWLQaH", "tyq_luckyBox", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("tyq_luckyBox", tyq_luckyBox = (_dec = ccclass('tyq_luckyBox'), _dec2 = property({
        type: Node,
        tooltip: "关闭按钮"
      }), _dec3 = property({
        type: Node,
        tooltip: "看视频按钮按钮"
      }), _dec4 = property({
        type: Node,
        tooltip: "宝箱存放的父节点"
      }), _dec5 = property({
        type: Node,
        tooltip: "钥匙存放的父节点"
      }), _dec6 = property({
        type: Prefab,
        tooltip: "宝箱预制体"
      }), _dec(_class = (_class2 = (_temp = /*#__PURE__*/function (_ref) {
        _inheritsLoose(tyq_luckyBox, _ref);

        function tyq_luckyBox() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _ref.call.apply(_ref, [this].concat(args)) || this;

          _initializerDefineProperty(_assertThisInitialized(_this), "closeBtn", _descriptor, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "videoBtn", _descriptor2, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "boxLayout", _descriptor3, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "keyLayout", _descriptor4, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "tyq_boxItem", _descriptor5, _assertThisInitialized(_this));

          _defineProperty(_assertThisInitialized(_this), "callback", null);

          _defineProperty(_assertThisInitialized(_this), "canTouch", true);

          _defineProperty(_assertThisInitialized(_this), "openNum", 0);

          _defineProperty(_assertThisInitialized(_this), "boxList", []);

          return _this;
        }

        var _proto = tyq_luckyBox.prototype;

        _proto.start = function start() {
          this.bindButton(this.closeBtn, this.closeFun);
          this.bindButton(this.videoBtn, this.videoFun);
          this.initBox();
          this.videoBtn.parent.active = false;
        };

        _proto.init = function init(next) {
          this.callback = next;
        }
        /**初始化宝箱 */
        ;

        _proto.initBox = function initBox() {
          var _this2 = this;

          //随机3个 视频宝箱变成普通宝箱 这里随机3个变成普通宝箱 
          var arry = [0, 1, 2, 3, 4, 5, 6, 7, 8];
          var randList = []; //

          for (var i = 0; i < 3; i++) {
            var rand1 = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).RandomNumBoth(0, arry.length - 1);
            var num1 = arry[rand1];
            arry.splice(rand1, 1);
            randList.push(num1);
          }

          var _loop = function _loop(_i) {
            _this2.boxList.push(_i);

            var type = true; //视频宝箱

            for (var j = 0; j < randList.length; j++) {
              if (_i == randList[j]) {
                type = false; //普通宝箱

                break;
              }
            }

            _this2.showUI(_this2.tyq_boxItem, _this2.boxLayout, function (comp) {
              comp.init(type);

              _this2.bindButton(comp.node, _this2.touchBox, _i, !type);
            });
          };

          for (var _i = 0; _i < 9; _i++) {
            _loop(_i);
          }
        }
        /**点击宝箱 */
        ;

        _proto.touchBox = function touchBox(index, isDefault) {
          var _this3 = this;

          if (!this.canTouch) return;
          this.canTouch = false;

          if (isDefault) {
            this.openBox(index);
          } else {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).showVideoAD("视频宝箱", function () {
              _this3.openBox(index);
            }, function () {
              _this3.canTouch = true;
            });
          }
        }
        /**打开宝箱
         * @param isDefault 是否是普通宝箱
         * @param index 宝箱编号
         */
        ;

        _proto.openBox = function openBox(index) {
          this.canTouch = true;
          var node = this.boxLayout.children[index];
          node.getComponent(ButtonComponent).enabled = false;
          var boxTs = node.getComponent(_crd && tyq_boxItem === void 0 ? (_reportPossibleCrUseOftyq_boxItem({
            error: Error()
          }), tyq_boxItem) : tyq_boxItem);
          var isDefault = boxTs.isWatch;
          boxTs.open(); //普通宝箱移除钥匙

          if (!isDefault) {
            this.keyLayout.children[0].destroy();
          }

          this.openNum++;

          if (this.openNum >= 3) {
            //开启超过3个显示关闭按钮
            this.videoBtn.parent.active = true;
          }

          if (this.openNum >= 9) {
            //开启超过9个隐藏看视频按钮
            this.videoBtn.active = false;
          }

          for (var i = 0; i < this.boxList.length; i++) {
            if (index == this.boxList[i]) {
              this.boxList.splice(i, 1);
              break;
            }
          }
        }
        /**右上角的关闭按钮 */
        ;

        _proto.closeFun = function closeFun() {
          this.next();
        }
        /**
         * 看视频
         */
        ;

        _proto.videoFun = function videoFun() {
          var _this4 = this;

          if (!this.canTouch) return;
          this.canTouch = false;
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).showVideoAD("再开一个", function () {
            var rand = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).RandomNumBoth(0, _this4.boxList.length - 1);
            var index = _this4.boxList[rand];

            _this4.openBox(index);
          }, function () {
            _this4.canTouch = true;
          });
        }
        /**离开幸运宝箱页面 */
        ;

        _proto.next = function next() {
          if (this.callback) {
            this.callback();
          }

          this.node.destroy();
        } // update (deltaTime: number) {
        //     // Your update function goes here.
        // }
        ;

        return tyq_luckyBox;
      }(_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "closeBtn", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "videoBtn", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "boxLayout", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "keyLayout", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "tyq_boxItem", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_luckyBox.js.map