System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, Widget, SDKbaseView, tyqSDK, _dec, _dec2, _dec3, _dec4, _class, _class2, _descriptor, _descriptor2, _descriptor3, _temp, _crd, ccclass, property, tyq_share;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      Widget = _cc.Widget;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "afd33SUS5ZBQrnEAE4utPN2", "tyq_share", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("tyq_share", tyq_share = (_dec = ccclass('tyq_share'), _dec2 = property({
        type: Node,
        tooltip: "分享按钮"
      }), _dec3 = property({
        type: Node,
        tooltip: "分享按钮2"
      }), _dec4 = property({
        type: Node,
        tooltip: "下一关按钮"
      }), _dec(_class = (_class2 = (_temp = /*#__PURE__*/function (_ref) {
        _inheritsLoose(tyq_share, _ref);

        function tyq_share() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _ref.call.apply(_ref, [this].concat(args)) || this;

          _initializerDefineProperty(_assertThisInitialized(_this), "shareBtn", _descriptor, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "shareBtn2", _descriptor2, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "next", _descriptor3, _assertThisInitialized(_this));

          _defineProperty(_assertThisInitialized(_this), "callback", null);

          return _this;
        }

        var _proto = tyq_share.prototype;

        _proto.start = function start() {
          this.bindButtonOce(this.shareBtn, this.shareVideo);
          this.bindButtonOce(this.shareBtn2, this.shareVideo);
          this.bindButtonOce(this.next, this.nextGame);
        };

        _proto.init = function init(callBack) {
          this.callback = callBack;
        }
        /**分享视频 */
        ;

        _proto.shareVideo = function shareVideo() {
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).RecordCut();
          this.shareBtn.active = false;

          this.shareVideo = function () {};
        }
        /**下一关 */
        ;

        _proto.nextGame = function nextGame() {
          var _this2 = this;

          if ((_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getSwitchInfoByName("bannerShare")) {
            // this.next.getComponent(WidgetComponent).enabled = false;
            this.scheduleOnce(function () {
              console.log(_this2.next.position);
              _this2.next.getComponent(Widget).bottom = 0.15;

              _this2.next.getComponent(Widget).updateAlignment();

              console.log(_this2.next.position);

              _this2.bindButton(_this2.next, _this2.nextFun);
            }, 1.5);
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).showBannerAD();
          } else {
            this.nextFun();
          }
        }
        /**真正的下一关逻辑 */
        ;

        _proto.nextFun = function nextFun() {
          if (this.callback) {
            this.callback();
          }

          this.node.destroy();
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).hideBannerAD();
        } // update (deltaTime: number) {
        //     // Your update function goes here.
        // }
        ;

        return tyq_share;
      }(_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "shareBtn", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "shareBtn2", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "next", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_share.js.map