System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, JsonAsset, resources, configTableMgr, _crd, ConfigTableMgr;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      JsonAsset = _cc.JsonAsset;
      resources = _cc.resources;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "a7e45gh5NFP9LcJDYWY2Ijl", "configTableMgr", undefined);

      /**
       * @description JSON表模块
       */
      configTableMgr = class configTableMgr {
        constructor() {
          _defineProperty(this, "configTableMap", {});
        }

        ////////////////////////////
        // get、set访问器
        ///////////////////////////
        ////////////////////////////
        // 接口
        ///////////////////////////

        /**
         * @description 加载json文件夹
         * @param pathName
         */
        loadConfigTable(pathName) {
          return new Promise((resolve, reject) => {
            resources.loadDir(pathName, JsonAsset, (err, resource) => {
              if (err) {
                console.error('=====> @framework, 加载配置表失败: ', err);
                reject();
                return;
              }

              resource.forEach(jsonAsset => {
                this.configTableMap[jsonAsset.name] = jsonAsset.json;
              });
              resolve();
            });
          });
        }
        /**
         * @description 获取json文件
         * @param jsonName
         */


        getConfigTableItem(jsonName) {
          let item = this.configTableMap[jsonName];

          if (item) {
            return item;
          } else {
            console.error(`=====> @framework, 获取配置表文件失败, 文件:${jsonName}.json 不存在`);
            return null;
          }
        }
        /**
         * 获取自选关卡数据
         */


        getSelfCreatorData() {
          return this.getConfigTableItem('selfCreator');
        }

      };

      _defineProperty(configTableMgr, "_instance", new configTableMgr());

      _export("ConfigTableMgr", ConfigTableMgr = configTableMgr._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=configTableMgr.js.map