System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, myCache, _crd, LocalCache;

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "3074aEk+CtIQa/GPvc/NDZm", "LocalCache", undefined);

      /**
       * 本地缓存管理模块
       */
      myCache = class myCache {
        /**
         * 获取缓存数据
         * @param key 键名
         */
        getItem(key) {
          let data = localStorage.getItem(key);
          return data ? data[0] == "[" || data[0] == "{" ? JSON.parse(data) : data : null;
        }
        /**
         * 缓存数据
         * @param key 键名
         * @param value 值
         */


        setItem(key, value) {
          let data = typeof value === 'string' ? value : JSON.stringify(value);
          localStorage.setItem(key, data);
        }
        /**
         * 删除缓存数据
         * @param key 键名
         */


        removeItemByKey(key) {
          localStorage.removeItem(key);
        }
        /**
         * 清空缓存数据
         */


        clear() {
          localStorage.clear();
        }

      };

      _export("LocalCache", LocalCache = new myCache());

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=LocalCache.js.map