System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, SpriteFrame, Texture2D, SpriteComponent, assetManager, SDKbaseView, tyqSDK, _dec, _class, _crd, ccclass, property, tyq_gameItemMini;

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOfgameInfo(extras) {
    _reporterNs.report("gameInfo", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      SpriteFrame = _cc.SpriteFrame;
      Texture2D = _cc.Texture2D;
      SpriteComponent = _cc.SpriteComponent;
      assetManager = _cc.assetManager;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "60c70Rd3ElNQKfCk6Ccw86C", "tyq_gameItemMini", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("tyq_gameItemMini", tyq_gameItemMini = (_dec = ccclass('tyq_gameItemMini'), _dec(_class = class tyq_gameItemMini extends (_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView) {
        init(from, value) {
          // if (TyqSdk.gameList.length < 12) return;
          assetManager.loadRemote(value.gameImg, (err, spf) => {
            if (err) {
              console.log(err);
              return;
            }

            ;
            const sp = new SpriteFrame();
            const tex = new Texture2D();
            tex.image = spf;
            sp.texture = tex;
            this.node.getComponent(SpriteComponent).spriteFrame = sp;
          });
          this.bindButton(this.node, () => {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).navigateToVideoView(value, from);
          });
        }

      }) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_gameItemMini.js.map