System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk", "./tyq_boxItem"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, Prefab, ButtonComponent, SDKbaseView, tyqSDK, tyq_boxItem, _dec, _dec2, _dec3, _dec4, _dec5, _dec6, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _descriptor5, _temp, _crd, ccclass, property, tyq_luckyBox;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyq_boxItem(extras) {
    _reporterNs.report("tyq_boxItem", "./tyq_boxItem", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      Prefab = _cc.Prefab;
      ButtonComponent = _cc.ButtonComponent;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }, function (_tyq_boxItem) {
      tyq_boxItem = _tyq_boxItem.tyq_boxItem;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "e8bb4pboYpADYo39uGWLQaH", "tyq_luckyBox", undefined);

      ({
        ccclass,
        property
      } = _decorator);

      _export("tyq_luckyBox", tyq_luckyBox = (_dec = ccclass('tyq_luckyBox'), _dec2 = property({
        type: Node,
        tooltip: "关闭按钮"
      }), _dec3 = property({
        type: Node,
        tooltip: "看视频按钮按钮"
      }), _dec4 = property({
        type: Node,
        tooltip: "宝箱存放的父节点"
      }), _dec5 = property({
        type: Node,
        tooltip: "钥匙存放的父节点"
      }), _dec6 = property({
        type: Prefab,
        tooltip: "宝箱预制体"
      }), _dec(_class = (_class2 = (_temp = class tyq_luckyBox extends (_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView) {
        constructor(...args) {
          super(...args);

          _initializerDefineProperty(this, "closeBtn", _descriptor, this);

          _initializerDefineProperty(this, "videoBtn", _descriptor2, this);

          _initializerDefineProperty(this, "boxLayout", _descriptor3, this);

          _initializerDefineProperty(this, "keyLayout", _descriptor4, this);

          _initializerDefineProperty(this, "tyq_boxItem", _descriptor5, this);

          _defineProperty(this, "callback", null);

          _defineProperty(this, "canTouch", true);

          _defineProperty(this, "openNum", 0);

          _defineProperty(this, "boxList", []);
        }

        start() {
          this.bindButton(this.closeBtn, this.closeFun);
          this.bindButton(this.videoBtn, this.videoFun);
          this.initBox();
          this.videoBtn.parent.active = false;
        }

        init(next) {
          this.callback = next;
        }
        /**初始化宝箱 */


        initBox() {
          //随机3个 视频宝箱变成普通宝箱 这里随机3个变成普通宝箱 
          let arry = [0, 1, 2, 3, 4, 5, 6, 7, 8];
          let randList = []; //

          for (let i = 0; i < 3; i++) {
            const rand1 = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).RandomNumBoth(0, arry.length - 1);
            const num1 = arry[rand1];
            arry.splice(rand1, 1);
            randList.push(num1);
          }

          for (let i = 0; i < 9; i++) {
            this.boxList.push(i);
            let type = true; //视频宝箱

            for (let j = 0; j < randList.length; j++) {
              if (i == randList[j]) {
                type = false; //普通宝箱

                break;
              }
            }

            this.showUI(this.tyq_boxItem, this.boxLayout, comp => {
              comp.init(type);
              this.bindButton(comp.node, this.touchBox, i, !type);
            });
          }
        }
        /**点击宝箱 */


        touchBox(index, isDefault) {
          if (!this.canTouch) return;
          this.canTouch = false;

          if (isDefault) {
            this.openBox(index);
          } else {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).showVideoAD("视频宝箱", () => {
              this.openBox(index);
            }, () => {
              this.canTouch = true;
            });
          }
        }
        /**打开宝箱
         * @param isDefault 是否是普通宝箱
         * @param index 宝箱编号
         */


        openBox(index) {
          this.canTouch = true;
          const node = this.boxLayout.children[index];
          node.getComponent(ButtonComponent).enabled = false;
          const boxTs = node.getComponent(_crd && tyq_boxItem === void 0 ? (_reportPossibleCrUseOftyq_boxItem({
            error: Error()
          }), tyq_boxItem) : tyq_boxItem);
          const isDefault = boxTs.isWatch;
          boxTs.open(); //普通宝箱移除钥匙

          if (!isDefault) {
            this.keyLayout.children[0].destroy();
          }

          this.openNum++;

          if (this.openNum >= 3) {
            //开启超过3个显示关闭按钮
            this.videoBtn.parent.active = true;
          }

          if (this.openNum >= 9) {
            //开启超过9个隐藏看视频按钮
            this.videoBtn.active = false;
          }

          for (let i = 0; i < this.boxList.length; i++) {
            if (index == this.boxList[i]) {
              this.boxList.splice(i, 1);
              break;
            }
          }
        }
        /**右上角的关闭按钮 */


        closeFun() {
          this.next();
        }
        /**
         * 看视频
         */


        videoFun() {
          if (!this.canTouch) return;
          this.canTouch = false;
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).showVideoAD("再开一个", () => {
            const rand = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).RandomNumBoth(0, this.boxList.length - 1);
            const index = this.boxList[rand];
            this.openBox(index);
          }, () => {
            this.canTouch = true;
          });
        }
        /**离开幸运宝箱页面 */


        next() {
          if (this.callback) {
            this.callback();
          }

          this.node.destroy();
        } // update (deltaTime: number) {
        //     // Your update function goes here.
        // }


      }, _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "closeBtn", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "videoBtn", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "boxLayout", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "keyLayout", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      }), _descriptor5 = _applyDecoratedDescriptor(_class2.prototype, "tyq_boxItem", [_dec6], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function () {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_luckyBox.js.map