System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _crd, DataManager;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "21bdbtbXChBkJaSLtlHH6Lh", "DataManager", undefined);

      DataManager = /*#__PURE__*/function () {
        function DataManager() {
          _defineProperty(this, "data", {});
        }

        var _proto = DataManager.prototype;

        _proto.getTable = function getTable(tableName) {
          return this.data[tableName];
        };

        _proto.handleData = function handleData(tableName, arr) {
          // 获取首行提示符
          var tips = arr[0].split(','); // 获取第二行字段类型

          var types = arr[1].split(','); // 获取第三行字段名字

          var names = arr[2].split(','); // 处理剩余数据

          var table = {};

          for (var i = 3; i < arr.length; i++) {
            var single = arr[i].split(/,/g);
            var obj = this.singleData(names, types, single, tableName, single[0]);
            var key = single[0];
            table[key] = obj;
          } // 加入表格


          this.data[tableName] = table;
        };

        _proto.singleData = function singleData(names, types, single, tableName, taK) {
          var obj = {};

          for (var i = 0; i < single.length; i++) {
            // 如果字段不存在则跳过
            if (!names[i]) {
              continue;
            } // 去除空格


            var key = names[i].replace(/\b\s*/g, "");
            var value = single[i].replace(/\b\s*/g, "");
            var typeName = types[i].replace(/\b\s*/g, ""); // 区分字段类型

            if (typeName == 'string') {
              obj[key] = value;
            } else if (typeName == "number") {
              obj[key] = Number(value);
            }
          }

          return obj;
        };

        _proto.GetTableByType = function GetTableByType(name, typename, type) {
          var list = [];
          var table = this.getTable(name);

          for (var i in table) {
            if (table[i]["" + typename] == type) {
              list.push(table[i]);
            }
          }

          return list;
        };

        _proto.GetTableByID = function GetTableByID(name, id) {
          var tabeldata;
          var table = this.getTable(name);

          for (var i in table) {
            if (table[i].id == id) {
              tabeldata = table[i];
              return tabeldata;
            }
          }

          return tabeldata;
        };

        return DataManager;
      }();

      _export("default", new DataManager());

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=DataManager.js.map