System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../../../config/GDef", "../../notifications"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, GDef, Notifications, _crd, oppoAdMange, OPPO;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfGDef(extras) {
    _reporterNs.report("GDef", "../../../config/GDef", _context.meta, extras);
  }

  function _reportPossibleCrUseOfNotifications(extras) {
    _reporterNs.report("Notifications", "../../notifications", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_configGDef) {
      GDef = _configGDef.default;
    }, function (_notifications) {
      Notifications = _notifications.Notifications;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "18ff6FLcTRGLqEAGZeJL9rX", "oppoAdMange", undefined);

      oppoAdMange = /*#__PURE__*/function () {
        function oppoAdMange() {
          _defineProperty(this, "rewardVideoAd", void 0);

          _defineProperty(this, "bannerAd", void 0);

          _defineProperty(this, "nativeAd", void 0);

          _defineProperty(this, "insertAd", void 0);

          _defineProperty(this, "_rewardVideoAdUnitId", '304847');

          _defineProperty(this, "_banneradUnitId", '304845');

          _defineProperty(this, "nativeadUnitId", '');

          _defineProperty(this, "insertAdUnitId", '');
        }

        var _proto = oppoAdMange.prototype;

        /**登陆接口 */
        _proto.login = function login() {
          qg.login({
            success: function success(res) {
              // 可全局储存 token，方便其他能力获取，注意 token 过期时间
              console.log("\u767B\u5F55\u6210\u529F: " + JSON.stringify(res.data));
            },
            fail: function fail(res) {
              console.log("\u767B\u5F55\u5931\u8D25: " + JSON.stringify(res));
            }
          });
        }
        /**获取授权信息  */
        ;

        _proto.getProfile = function getProfile(_token) {
          return new Promise(function (resolve, reject) {
            qg.getProfile({
              token: _token,
              success: function success(data) {
                resolve(data);
              },
              fail: function fail(data, code) {
                reject(data);
              }
            });
          });
        }
        /**  退出游戏，同步方法*/
        ;

        _proto.exitApplication = function exitApplication() {
          qg.exitApplication();
        }
        /**使手机发生较短时间的振动（20 ms） */
        ;

        _proto.vibrateShort = function vibrateShort() {
          qg.vibrateShort({
            success: function success(res) {},
            fail: function fail(res) {},
            complete: function complete(res) {}
          });
        }
        /**使手机发生较长时间的振动（400 ms) */
        ;

        _proto.vibrateLong = function vibrateLong() {
          qg.vibrateLong({
            success: function success(res) {},
            fail: function fail(res) {},
            complete: function complete(res) {}
          });
        } //=============================广告

        /**展示激励视频 */
        ;

        _proto.showRewardVideoAd = function showRewardVideoAd(cb, fail) {
          var _this = this;

          console.log("展示激励视频"); //    if(this.systemInfo.minPlatformVersion<1051)return
          // return new Promise<void>((resolve, reject) => {

          this.rewardVideoAd = qg.createRewardedVideoAd({
            adUnitId: this._rewardVideoAdUnitId
          });
          console.log('加载广告');
          this.rewardVideoAd.load().then(function () {
            console.log('promise 回调：加载成功');
            console.log('展示广告'); // 调用 show 方法请求展示 banner，成功的时候回调 onShow，出错的时候回调 onError

            _this.rewardVideoAd.show().then(function () {
              console.log('promise 回调：展示成功');
            })["catch"](function (err) {
              console.log("promise \u56DE\u8C03\uFF1A\u5C55\u793A\u5931\u8D25 " + JSON.stringify(err));

              if (fail) {
                fail();
                (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                  error: Error()
                }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                  error: Error()
                }), GDef) : GDef).wdEvent.VideoErr, "观看广告失败:广告展示失败");
                return;
              }
            });
          })["catch"](function (err) {
            console.log("promise \u56DE\u8C03\uFF1A\u52A0\u8F7D\u5931\u8D25 " + JSON.stringify(err));

            if (fail) {
              fail();
              (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                error: Error()
              }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                error: Error()
              }), GDef) : GDef).wdEvent.VideoErr, "观看广告失败:广告加载失败");
              return;
            }
          });
          this.rewardVideoAd.onClose(function (res) {
            if (res.isEnded) {
              cc.log('激励视频广告完成，发放奖励');
              cb();

              _this.rewardVideoAd.offClose(); // resolve();

            } else {
              cc.log('激励视频广告取消关闭，不发放奖励'); // reject();

              _this.rewardVideoAd.offClose();

              if (fail) {
                fail();
                (_crd && Notifications === void 0 ? (_reportPossibleCrUseOfNotifications({
                  error: Error()
                }), Notifications) : Notifications).emit((_crd && GDef === void 0 ? (_reportPossibleCrUseOfGDef({
                  error: Error()
                }), GDef) : GDef).wdEvent.VideoErr, "观看广告失败");
              }
            }
          }); // })
        }
        /**展示Banner广告 */
        ;

        _proto.showBannerAd = function showBannerAd() {
          console.log("展示banner视频");
          if (this.systemInfo.minPlatformVersion < 1051) return;

          if (this.bannerAd) {
            return;
          }

          this.bannerAd = qg.createBannerAd({
            adUnitId: this._banneradUnitId
          });
          console.log("创建成功");
          this.bannerAd.onLoad(function () {
            cc.log('banner 广告加载成功');
          });
          this.bannerAd.show(function () {
            cc.log('banner 广告显示');
          });
          this.bannerAd.onError(function (err) {
            cc.error("banner 广告出错");
            cc.error(JSON.stringify(err));
            this.bannerAd.destroy();
            this.bannerAd = null;
          });
        }
        /**隐藏Banner广告 */
        ;

        _proto.hideBannerAd = function hideBannerAd() {
          if (this.bannerAd) {
            this.bannerAd.hide();
            this.bannerAd.destroy();
            this.bannerAd = null;
          }
        }
        /**展示原生插屏广告 */
        ;

        _proto.showInterstitialAd = function showInterstitialAd() {}
        /**原生插屏 */
        ;

        _proto.creatorInterstitialAd = function creatorInterstitialAd() {}
        /**创建原生广告 */
        ;

        _proto.createNativeAd = function createNativeAd() {
          if (this.systemInfo.platformVersionCode < 1051) return;
          this.nativeAd = qg.createNativeAd({
            posId: this.nativeadUnitId
          });
          console.log("原生广告原生广告", this.nativeAd);
          this.nativeAd.onLoad(function (res) {
            if (res && res.adList) {
              console.log("原生广告", res);
              this.clickNativeAd(res.adList);
            }
          });
          this.nativeAd.onError(function (res) {
            console.log('原生广告加载失败', res);
          });
          var adLoad = this.nativeAd.load();
          adLoad && adLoad.then(function () {
            console.log("原生广告加载成功");
          })["catch"](function (err) {
            console.log('原生广告加载失败', JSON.stringify(err));
          });
        }
        /**上报原生点击 */
        ;

        _proto.clickNativeAd = function clickNativeAd(adId) {
          this.nativeAd.reportAdClick({
            adId: adId
          });
        } // 检查登录信息 5分钟后token 失效
        ;

        _proto.getSetting = function getSetting(cbOK, cbFail) {
          if (cbFail === void 0) {
            cbFail = null;
          }
        }
        /**判断是否已经创建桌面图标 */
        ;

        _proto.hasShortcutInstalled = function hasShortcutInstalled() {
          this.login();
          qg.hasShortcutInstalled({
            success: function success(res) {
              // 判断图标未存在时，创建图标
              if (res == false) {
                qg.installShortcut({
                  success: function success() {// 执行用户创建图标奖励
                  },
                  fail: function fail(err) {},
                  complete: function complete() {}
                });
              }
            },
            fail: function fail(err) {},
            complete: function complete() {}
          });
        }
        /**设置游戏加载进度页面（该功能必须接入，否则会因为未接入，导致游戏加载页进度条缺失而被测试打回） */
        ;

        _proto.setLoadingProgress = function setLoadingProgress() {
          qg.setLoadingProgress({
            progress: 50
          });
        }
        /**隐藏游戏加载进度页面 */
        ;

        _proto.loadingComplete = function loadingComplete() {
          qg.loadingComplete({
            complete: function complete(res) {}
          });
        };

        _createClass(oppoAdMange, [{
          key: "bannerAdUnitId",
          set: function set(adUnitId) {
            this._banneradUnitId = adUnitId;
          }
        }, {
          key: "rewardedVideoAdUnitId",
          set: function set(adUnitId) {
            this._rewardVideoAdUnitId = adUnitId;
          } //获取系统信息的同步版本

        }, {
          key: "systemInfo",
          get: function get() {
            return qg.getSystemInfoSync();
          }
        }]);

        return oppoAdMange;
      }();

      _defineProperty(oppoAdMange, "_instance", new oppoAdMange());

      _export("OPPO", OPPO = oppoAdMange._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=oppoAdMange.js.map