System.register(["cce:/internal/code-quality/cr.mjs", "cc", "../networkMgr"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, NetworkMgr, _crd, http, Http;

  function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

  function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _reportPossibleCrUseOfNetworkMgr(extras) {
    _reporterNs.report("NetworkMgr", "../networkMgr", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
    }, function (_networkMgr) {
      NetworkMgr = _networkMgr.NetworkMgr;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "dd33blB94dCpaxVy8X0MVp4", "http", undefined);

      http = /*#__PURE__*/function () {
        ////////////////////////////
        // 构造函数
        ///////////////////////////
        function http() {
          _defineProperty(this, "_timeOut", 10 * 1000);

          _defineProperty(this, "_httpUrl", 'https://minigame.xmtyq.com/');

          _defineProperty(this, "DES3_KEY", "qXSdHWfbSZaaLeHTTxGZQLXY");
        }

        var _proto = http.prototype;

        _proto.init = function init(httpUrl) {
          this._httpUrl = httpUrl;
        }
        /**
         * 发送请求
         * @param route 注册事件，通过消息机制返回服务端回调的信息
         * @param msg 请求数据
         * @param mid 
         */
        ;

        _proto.post = function post(route, msg, mid) {
          var dataStr = "";

          if (msg) {
            dataStr = JSON.stringify(msg);
          }

          var xhr = new XMLHttpRequest(); //cc.loader.getXMLHttpRequest();
          // 超时时间1s，单位是毫秒

          xhr.timeout = this._timeOut;
          xhr.open('POST', this._httpUrl + route, true); // 服务端也需要设置

          xhr.setRequestHeader("Content-Type", "application/x-www-form-urlencoded"); //DES3加密
          //	console.log(dataStr);

          dataStr = this.strToDES3(dataStr);
          xhr.send('data=' + dataStr);

          xhr.onreadystatechange = function onreadystatechange() {
            // 请求完成。在此进行处理。
            if (xhr.readyState === 4 && xhr.status >= 200 && xhr.status < 300) {
              var respone = xhr.responseText;

              if (!respone) {
                // console.error('http request respone is null');
                (_crd && NetworkMgr === void 0 ? (_reportPossibleCrUseOfNetworkMgr({
                  error: Error()
                }), NetworkMgr) : NetworkMgr).onHttpError(mid, null, 'http request respone is null');
                return;
              }

              (_crd && NetworkMgr === void 0 ? (_reportPossibleCrUseOfNetworkMgr({
                error: Error()
              }), NetworkMgr) : NetworkMgr).checkRespone(route, respone, mid);
            }
          }.bind(this); // XMLHttpRequest 超时


          xhr.ontimeout = function ontimeout(error) {
            console.error('http request timeout: ', error);
            (_crd && NetworkMgr === void 0 ? (_reportPossibleCrUseOfNetworkMgr({
              error: Error()
            }), NetworkMgr) : NetworkMgr).onHttpError(mid, error, 'http request timeout: ');
          }.bind(this); // XMLHttpRequest 错误


          xhr.onerror = function onerror(error) {
            // console.error('http request error: ', error);
            (_crd && NetworkMgr === void 0 ? (_reportPossibleCrUseOfNetworkMgr({
              error: Error()
            }), NetworkMgr) : NetworkMgr).onHttpError(mid, error, 'http request error: '); // alert('网络通信失败，请刷新重试。');
          }.bind(this);
        }
        /**
         * GET 请求
         * @param route 
         * @param msg 
         * @param mid 
         */
        ;

        _proto.post2 = function post2(route, msg, mid) {
          var str = this.MsgToString(msg);
          var xhr = new XMLHttpRequest(); // 超时时间1s，单位是毫秒

          xhr.timeout = this._timeOut;
          xhr.open('GET', this._httpUrl + route + "?" + str, true); // 服务端也需要设置

          xhr.setRequestHeader("Content-Type", "text/plain;charset=UTF-8");
          xhr.send(JSON.stringify(msg));

          xhr.onreadystatechange = function onreadystatechange() {
            // 请求完成。在此进行处理。
            if (xhr.readyState === 4 && xhr.status >= 200 && xhr.status < 300) {
              // console.log("返回"+xhr);
              var respone = xhr.responseText;

              if (!respone) {
                // console.error('http request respone is null');
                (_crd && NetworkMgr === void 0 ? (_reportPossibleCrUseOfNetworkMgr({
                  error: Error()
                }), NetworkMgr) : NetworkMgr).onHttpError(mid, null, 'http request respone is null');
                return;
              } //		console.log("服务端设置");
              //		console.log(respone);


              (_crd && NetworkMgr === void 0 ? (_reportPossibleCrUseOfNetworkMgr({
                error: Error()
              }), NetworkMgr) : NetworkMgr).checkRespone(route, respone, mid);
            }
          }.bind(this); // XMLHttpRequest 超时


          xhr.ontimeout = function ontimeout(error) {
            console.error('http request timeout: ', error); // NetworkMgr.onHttpError(mid, res, 'http request timeout: ');
          }.bind(this); // XMLHttpRequest 错误


          xhr.onerror = function onerror(error) {
            (_crd && NetworkMgr === void 0 ? (_reportPossibleCrUseOfNetworkMgr({
              error: Error()
            }), NetworkMgr) : NetworkMgr).onHttpError(mid, error, 'http request error: ');
          }.bind(this);
        }
        /**
         * Get请求，将json转换成字符串数据
         */
        ;

        _proto.MsgToString = function MsgToString(msg) {
          var arr = Object.keys(msg);
          var str = "";

          for (var _i = 0, _arr = arr; _i < _arr.length; _i++) {
            var value = _arr[_i];
            str += value + "=" + '"' + msg[value] + '"' + "&";
          }

          return str;
        }
        /**
         * 数据加密
         */
        ;

        _proto.strToDES3 = function strToDES3(data) {// let des3Data: string = window["DES3"].encrypt(this.DES3_KEY, data);
          // let newData = des3Data.replace(/\+/g, "%2B");
          // return newData;
        };

        _createClass(http, [{
          key: "timeOut",
          set: ////////////////////////////
          // 类成员
          ///////////////////////////

          /**加密参数 */
          ////////////////////////////
          // get、set构造器
          ///////////////////////////
          function set(time) {
            this._timeOut = time;
          }
        }, {
          key: "httpUrl",
          set: function set(url) {
            this._httpUrl = url;
          }
        }]);

        return http;
      }();

      _defineProperty(http, "_instance", new http());

      _export("Http", Http = http._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=http.js.map