System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./FileSaver", "../config/global"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, Node, SaveAs, global, _dec, _dec2, _dec3, _class, _class2, _descriptor, _descriptor2, _temp, _crd, ccclass, property, LevelGame;

  function _createForOfIteratorHelperLoose(o, allowArrayLike) { var it; if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; return function () { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } it = o[Symbol.iterator](); return it.next.bind(it); }

  function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

  function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSaveAs(extras) {
    _reporterNs.report("SaveAs", "./FileSaver", _context.meta, extras);
  }

  function _reportPossibleCrUseOfglobal(extras) {
    _reporterNs.report("global", "../config/global", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
    }, function (_FileSaver) {
      SaveAs = _FileSaver.SaveAs;
    }, function (_configGlobal) {
      global = _configGlobal.default;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "688f2fXWQtL8rZyhMQyJEeR", "LevelGame", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("LevelGame", LevelGame = (_dec = ccclass('LevelGame'), _dec2 = property({
        tooltip: "关卡"
      }), _dec3 = property({
        type: Node
      }), _dec(_class = (_class2 = (_temp = /*#__PURE__*/function (_Component) {
        _inheritsLoose(LevelGame, _Component);

        function LevelGame() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _Component.call.apply(_Component, [this].concat(args)) || this;

          _initializerDefineProperty(_assertThisInitialized(_this), "level", _descriptor, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "btn", _descriptor2, _assertThisInitialized(_this));

          _defineProperty(_assertThisInitialized(_this), "blob", void 0);

          return _this;
        }

        var _proto = LevelGame.prototype;

        _proto.onLoad = function onLoad() {
          var _this2 = this;

          this.btn.on('click', function () {
            (_crd && SaveAs === void 0 ? (_reportPossibleCrUseOfSaveAs({
              error: Error()
            }), SaveAs) : SaveAs)(_this2.blob, "level" + _this2.level + ".csv");
          });
        };

        _proto.start = function start() {
          if (this.node.active == true) {
            this.btn.active = true;
            this.btn.parent.active = true;
          } else {
            this.btn.active = false;
          }

          this.scheduleOnce(this.check, 1);
        };

        _proto.check = function check() {
          var data1 = '';
          var index = 0;
          var da = '索引,' + '节点名字,' + 'posX,' + 'posY,' + 'posZ,' + 'rotX,' + 'rotY,' + 'rotZ,' + 'ScaX,' + 'ScaY,' + 'ScaZ,' + 'Type' + 'Type2' + '\n' + 'number,' + 'string,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number,' + 'number' + 'number' + '\n' + 'ID,' + 'name,' + 'posX,' + 'posY,' + 'posZ,' + 'rotX,' + 'rotY,' + 'rotZ,' + 'ScaX,' + 'ScaY,' + 'ScaZ,' + 'Type' + 'Type2' + '\n';
          data1 += da;

          for (var _iterator = _createForOfIteratorHelperLoose(this.node.children), _step; !(_step = _iterator()).done;) {
            var value = _step.value;
            index++;
            var type = 0;
            var nodeName = value.name; //道具分组

            if (nodeName == "prefab_group") {
              da = this.getNodeValueStr(value, index, type);
              data1 += da;

              for (var _iterator2 = _createForOfIteratorHelperLoose(value.children), _step2; !(_step2 = _iterator2()).done;) {
                var value2 = _step2.value;
                index++;
                var type2 = 0;
                var nodeName2 = value2.name;
                var moveLength = 0; //特殊处理的道具 

                if ((_crd && global === void 0 ? (_reportPossibleCrUseOfglobal({
                  error: Error()
                }), global) : global).arrProp.indexOf(nodeName2) > -1) {
                  type2 = value2.getComponent(Props).Value;
                  moveLength = value2.getComponent(Props).moveLength;
                }

                da = this.getNodeValueStr(value2, index, type2, moveLength);
                data1 += da;
              }

              continue;
            }

            if (nodeName == "prefab_curve") {
              type = value.getComponent(prefab_curve).anger;
            }

            da = this.getNodeValueStr(value, index, type);
            data1 += da;
          }

          var content = data1;
          this.blob = new Blob([content], {
            type: "text/csv;charset=utf-8"
          });
        };

        _proto.getNodeValueStr = function getNodeValueStr(node, index, type, type2) {
          if (type2 === void 0) {
            type2 = 0;
          }

          var str = index + ',' + node.name + "," + Number(node.position.x.toFixed(3)) + "," + Number(node.position.y.toFixed(3)) + "," + Number(node.position.z.toFixed(3)) + "," + Number(node.eulerAngles.x.toFixed(3)) + "," + Number(node.eulerAngles.y.toFixed(3)) + "," + Number(node.eulerAngles.z.toFixed(3)) + "," + Number(node.scale.x.toFixed(3)) + ',' + Number(node.scale.y.toFixed(3)) + "," + Number(node.scale.z.toFixed(3)) + "," + type + "," + type2 + '\n';
          return str;
        };

        return LevelGame;
      }(Component), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "level", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return 0;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "btn", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=LevelGame.js.map