System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, instantiate, NodePool, _crd, poolMgr, PooLMgr;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      instantiate = _cc.instantiate;
      NodePool = _cc.NodePool;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "3273aci55xCALGp55n+rs01", "poolMgr", undefined);

      poolMgr = /*#__PURE__*/function () {
        function poolMgr() {
          _defineProperty(this, "poolArry", {});
        }

        var _proto = poolMgr.prototype;

        //对象池组

        /**
         * 创建对象池
         * @param cPrefab 预制体
         * @param count 要创建的数量
         */
        _proto.creatorPool = function creatorPool(cPrefab, count) {
          var cPool = new NodePool();

          for (var i = 0; i < count; i++) {
            var node = instantiate(cPrefab);
            cPool.put(node);
          } //对象池JSON 用预制体名字做key


          this.poolArry[cPrefab.data.name] = {
            nodePool: cPool
          };
        }
        /**
        * 回收对象池
        * @param node 要回收的节点
        */
        ;

        _proto.recoveryPool = function recoveryPool(node) {
          var poolName = node.name;

          if (this.poolArry[poolName]) {
            this.poolArry[poolName].nodePool.put(node);
          } else {
            console.error("objLayer no this pool", poolName);
            node.destroy();
          }
        }
        /**
        * 获取对象池节点
        * @param cPrefab 预制体名称 
        */
        ;

        _proto.getPoolObj = function getPoolObj(cPrefab) {
          var prefabName = cPrefab.data.name;

          if (this.poolArry[prefabName] && this.poolArry[prefabName].nodePool.size() > 0) {
            return this.poolArry[prefabName].nodePool.get();
          } else {
            this.creatorPool(cPrefab, 1);
            return this.poolArry[prefabName].nodePool.get();
          }
        };

        return poolMgr;
      }();

      _defineProperty(poolMgr, "_instance", new poolMgr());

      _export("PooLMgr", PooLMgr = poolMgr._instance);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=poolMgr.js.map