System.register(["cc"], function (_export, _context) {
  "use strict";

  var _cclegacy, _decorator, Vec3, math, v2, _dec, _class, _crd, ccclass, property, UtilsMath, MathRandom, MathUtil;

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  return {
    setters: [function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Vec3 = _cc.Vec3;
      math = _cc.math;
      v2 = _cc.v2;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "0ee87WBIbdEVIkh4I6cegLP", "UtilsMath", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("default",
      /**
       * Created by 许宇
       *
       * UtilsMath
       * 数学工具
       */
      // main
      UtilsMath = (_dec = ccclass("UtilsMath"), _dec(_class = /*#__PURE__*/function () {
        function UtilsMath() {}

        var _proto3 = UtilsMath.prototype;

        /**
         * 数字变字符串，长度不足前补0
         */
        _proto3.textNumString = function textNumString(num, len) {
          if (len === void 0) {
            len = 2;
          }

          var need = len - String(num).length;
          var str = "";

          for (var i = 0; i < need; i++) {
            str += "0";
          }

          str += num;
          return str;
        }
        /**
        * 已知两点求距离
        * @param {cc.Vec2} pos1
        * @param {cc.Vec2} pos2
        */
        ;

        _proto3.calcDistance = function calcDistance(pos1, pos2) {
          var xdiff = pos1.x - pos2.x;
          var ydiff = pos1.y - pos2.y;
          var dis = Math.pow(xdiff * xdiff + ydiff * ydiff, 0.5);
          return dis;
        };

        /**
         * 转换ccc的角度
         * @param angle
         */
        _proto3.fixAngle = function fixAngle(angle) {
          angle = -angle % 360;
          if (angle > 180) angle = -180 + angle % 180;else if (angle < -180) angle = 180 + angle % 180;
          return angle;
        }
        /**
         * 获得随机数
         * @param maxNum 上限
         * @param minNum 下限
         * @param floatLen 取小数点后n位
         */
        ;

        _proto3.getRandom = function getRandom(maxNum, minNum) {
          return MathRandom.getInstance().randomRange(minNum, maxNum);
        };

        _proto3.getRandom2 = function getRandom2(maxNum, minNum, floatLen) {
          if (floatLen === void 0) {
            floatLen = 0;
          }

          var ranNum = 0;
          ranNum = MathRandom.getInstance().random() * (maxNum - minNum + 1) + minNum;

          if (floatLen > 0) {
            ranNum = parseFloat(ranNum.toFixed(floatLen));
          } else ranNum = parseInt(ranNum + '');

          return ranNum;
        };

        _proto3.getRandom3 = function getRandom3(maxNum, minNum, floatLen) {
          if (floatLen === void 0) {
            floatLen = 0;
          }

          var ranNum = 0;
          ranNum = Math.random() * (maxNum - minNum + 1) + minNum;

          if (floatLen > 0) {
            ranNum = parseFloat(ranNum.toFixed(floatLen));
          } else ranNum = parseInt(ranNum + '');

          return ranNum;
        };

        _proto3.setRandomSeed = function setRandomSeed(value) {
          MathRandom.getInstance().setSeed(value);
        };

        /**
         * 不四舍五入保留小数固定几位
         * @param nOriginalNum 原始数字
         * @param nFixed 保留小数的位数
         * @param bCeil 是否取上限
         */
        _proto3.toFixedUnRound = function toFixedUnRound(nOriginalNum, nFixed, bCeil) {
          if (bCeil === void 0) {
            bCeil = false;
          }

          var nNewValue = 0;
          var nEqualPower = Math.pow(10, nFixed);

          if (bCeil) {
            nNewValue = Math.ceil(nOriginalNum * nEqualPower) / nEqualPower;
          } else {
            nNewValue = Math.floor(nOriginalNum * nEqualPower) / nEqualPower;
          }

          return nNewValue;
        }
        /**
         * 取小数点后n位
         * @param value
         * @param len 小数位数
         * @param mode 取整方式 1=四舍五入，2=向上取整，3=向下取整
         */
        ;

        _proto3.toFixed = function toFixed(value, len, mode) {
          if (len === void 0) {
            len = 2;
          }

          if (mode === void 0) {
            mode = 1;
          }

          var pow = Math.pow(10, len);

          switch (mode) {
            case 1:
              return Math.round(value * pow) / pow;

            case 2:
              return Math.ceil(value * pow) / pow;

            case 3:
              return Math.floor(value * pow) / pow;
          }
        };

        return UtilsMath;
      }()) || _class));

      ;
      /**
       * MathRandom
       * 随机数
       */

      _export("MathRandom", MathRandom = /*#__PURE__*/function () {
        function MathRandom() {
          _defineProperty(this, "_seed", 12345);
        }

        MathRandom.getInstance = function getInstance() {
          if (!MathRandom._instance) {
            MathRandom._instance = new MathRandom();
          }

          return this._instance;
        };

        var _proto = MathRandom.prototype;

        // private _seed = 123456789;
        // private m_z = 987654321;
        // private mask = 0xffffffff;
        _proto.setSeed = function setSeed(value) {
          this._seed = value;
        };

        _proto.random = function random() {
          // this.m_z = (36969 * (this.m_z & 65535) + (this.m_z >> 16)) & this.mask;
          // this._seed = (18000 * (this._seed & 65535) + (this._seed >> 16)) & this.mask;
          // let result = ((this.m_z << 16) + this._seed) & this.mask;
          // result /= 4294967296;
          // return result + 0.5;
          this._seed = (this._seed * 9301 + 49297) % 233280;
          return Math.ceil(this._seed);
        };

        _proto.randomRange = function randomRange(min, max) {
          if (min == max) {
            return max;
          }

          min = typeof min !== "undefined" ? min : 0;
          max = typeof max !== "undefined" ? max : 1;
          var range = max - min;
          var ss = this.random();
          return Math.floor(min + ss % range);
        }
        /**
         * 直接随机
         * @param 最小
         * @param 最大 
         */
        ;

        _proto.RandomNumBoth = function RandomNumBoth(Min, Max) {
          var Range = Max - Min;
          var Rand = Math.random();
          var num = Min + Math.round(Rand * Range); //四舍五入

          return num;
        };

        return MathRandom;
      }());

      _defineProperty(MathRandom, "_instance", void 0);

      ;

      _export("MathUtil", MathUtil = /*#__PURE__*/function () {
        function MathUtil() {}

        MathUtil.getInstance = function getInstance() {
          if (!MathUtil._instance) {
            MathUtil._instance = new MathUtil();
          }

          return this._instance;
        }
        /**
         * 已经点A，角度，半径，求点B
         * @param {number} x
         * @param {number} y
         * @param {number} radius 半径
         * @param {any} angle 角度
         */
        ;

        var _proto2 = MathUtil.prototype;

        _proto2.getPointB = function getPointB(x, y, radius, angle) {
          var a = Math.cos(this.getEulerAngle(angle)).toFixed(2);
          var b = Math.sin(this.getEulerAngle(angle)).toFixed(2);
          var newX = x + radius * Number(a);
          var newY = y + radius * Number(b);
          return v2(newX, newY);
        }
        /**
         * 已知点A 圆心 旋转角度，求点B
         * @param posA 点A
         * @param circleCenter 圆心
         * @param angle 旋转角度，向右旋转为-90；
         */
        ;

        _proto2.getPointB2 = function getPointB2(posA, circleCenter, angle) {
          var rot = angle >= 0 ? angle + 180 : angle + 90;
          var dis = this.calcDistance(posA, circleCenter);
          var posb = this.getPointB(circleCenter.x, circleCenter.y, dis, rot);
          return posb;
        }
        /**
         * 转换成欧拉角
         * @param angle
         */
        ;

        _proto2.getEulerAngle = function getEulerAngle(angle) {
          return angle * Math.PI / 180;
        };

        /**
             * 已知两点求角度
             * @param pos1 坐标1 相当于原点
             * @param pos2 坐标2
             * @param is360 是否输出360°的格式
             */
        _proto2.getAngle2 = function getAngle2(pos1, pos2, is360) {
          if (is360 === void 0) {
            is360 = false;
          }

          var x = pos2.x - pos1.x;
          var y = pos2.y - pos1.y;
          var xrad = Math.atan2(y, x); //注意参数（y, x） Y在前，X在后

          var angle = xrad / Math.PI * 180;
          if (is360 && angle < 0) angle += 360;
          return angle;
        }
        /**
          * 已知两点求角度
          * @param {number} x1
          * @param {number} y1
          * @param {number} x2
          * @param {number} y2
          */
        ;

        _proto2.getAngle = function getAngle(x1, y1, x2, y2) {
          var radian = this.getRadian(x1, y1, x2, y2); //求出弧度

          var angle = 180 / (Math.PI / radian); //用弧度算出角度

          var x = x2 - x1;
          var y = y2 - y1;
          if (y < 0) angle = -angle;else if (y == 0 && x < 0) angle = 180;
          return angle;
        }
        /**
         * 已知两点求弧度
         * @param {number} x1
         * @param {number} y1
         * @param {number} x2
         * @param {number} y2
         */
        ;

        _proto2.getRadian = function getRadian(x1, y1, x2, y2) {
          //两点的x、y值
          var x = x2 - x1;
          var y = y2 - y1;
          var hypotenuse = Math.sqrt(Math.pow(x, 2) + Math.pow(y, 2)); //斜边长度

          var cos = x / hypotenuse;
          var radian = Math.acos(cos);
          return radian;
        }
        /**
        * 已知两点求距离(3D)
        * @param {cc.Vec2} pos1
        * @param {cc.Vec2} pos2
        */
        ;

        _proto2.calcDistance3D = function calcDistance3D(pos1, pos2) {
          var xdiff = pos1.x - pos2.x;
          var ydiff = pos1.y - pos2.y;
          var zdiff = pos1.z - pos2.z;
          var dis = Math.pow(xdiff * xdiff + ydiff * ydiff + zdiff * zdiff, 0.5);
          return dis;
        };

        /**
        * 已知两点求距离
        * @param {cc.Vec2} pos1
        * @param {cc.Vec2} pos2
        */
        _proto2.calcDistance = function calcDistance(pos1, pos2) {
          var xdiff = pos1.x - pos2.x;
          var ydiff = pos1.y - pos2.y;
          var dis = Math.pow(xdiff * xdiff + ydiff * ydiff, 0.5);
          return dis;
        };

        /**
        * 根据自身方向转换方向 （保持朝向前进）
        * @param x 
        * @param y 
        * @param z 
        * @param node 获取方向的节点
        */
        _proto2.getDirection = function getDirection(x, y, z, node) {
          var result = new Vec3(x, y, z);
          math.Vec3.transformQuat(result, result, node.getRotation());
          return result;
        };

        return MathUtil;
      }());

      _defineProperty(MathUtil, "_instance", void 0);

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=UtilsMath.js.map