System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, Node, Tween, tween, v3, ProgressBarComponent, tyqSDK, _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp, _crd, ccclass, property, tyq_crazyBox;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      Tween = _cc.Tween;
      tween = _cc.tween;
      v3 = _cc.v3;
      ProgressBarComponent = _cc.ProgressBarComponent;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "4bdb9rw6CZBlIVOX/zMfVL3", "tyq_crazyBox", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("tyq_crazyBox", tyq_crazyBox = (_dec = ccclass('tyq_crazyBox'), _dec2 = property({
        type: Node,
        tooltip: "宝箱icon，用来做动画"
      }), _dec3 = property({
        type: ProgressBarComponent,
        tooltip: "进度条"
      }), _dec4 = property({
        type: Node,
        tooltip: "蛋壳上半部分"
      }), _dec5 = property({
        type: Node,
        tooltip: "钻石"
      }), _dec(_class = (_class2 = (_temp = /*#__PURE__*/function (_Component) {
        _inheritsLoose(tyq_crazyBox, _Component);

        function tyq_crazyBox() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _Component.call.apply(_Component, [this].concat(args)) || this;

          _initializerDefineProperty(_assertThisInitialized(_this), "box", _descriptor, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "progress", _descriptor2, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "Eggshell", _descriptor3, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "diamonds", _descriptor4, _assertThisInitialized(_this));

          _defineProperty(_assertThisInitialized(_this), "twn", new Tween());

          _defineProperty(_assertThisInitialized(_this), "addNum", 0.1);

          _defineProperty(_assertThisInitialized(_this), "cutNum", 0.005);

          _defineProperty(_assertThisInitialized(_this), "openAD", 3);

          _defineProperty(_assertThisInitialized(_this), "canTouch", true);

          _defineProperty(_assertThisInitialized(_this), "callBack", null);

          _defineProperty(_assertThisInitialized(_this), "schFun", false);

          return _this;
        }

        var _proto = tyq_crazyBox.prototype;

        _proto.start = function start() {// Your initialization goes here.
        };

        _proto.inint = function inint(callBack) {
          this.node.active = true;
          this.callBack = callBack;
          this.canTouch = true;
          this.progress.progress = 0;
          var arry = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).getSwitchValue("crazyEggOperCtr"); //狂点彩蛋控制

          if (arry) {
            var openList = arry.split(",");

            if (openList.length > 2) {
              this.addNum = Number(openList[0]); //一次的进度

              this.cutNum = Number(openList[1]); //一次倒退的进度

              this.openAD = Number(openList[2]); //多久后打开视频广告
            }
          }
        };

        _proto.openBtnFun = function openBtnFun() {
          var _this2 = this;

          if (!this.canTouch) return;

          if (!this.schFun) {
            this.schFun = true;
            this.scheduleOnce(function () {
              _this2.nextFun();
            }, this.openAD);
          }

          this.twn.stop();
          this.twn = tween(this.box).to(0.05, {
            eulerAngles: v3(0, 0, 10)
          }).to(0.1, {
            eulerAngles: v3(0, 0, -10)
          }).to(0.05, {
            eulerAngles: v3(0, 0, 0)
          }).union().start();
          this.progress.progress += this.addNum; //0.25表示进度百分比
          // if (this.progress.progress > this.openAD && this.canTouch) {
          //     this.nextFun();
          // }
        };

        _proto.nextFun = function nextFun() {
          var _this3 = this;

          this.canTouch = false;
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).showVideoAD("狂点彩蛋", function () {
            //打开彩蛋
            tween(_this3.Eggshell).by(1, {
              eulerAngles: v3(0, 0, -60)
            }).call(function () {
              _this3.diamonds.active = true;
            }).delay(1).call(function () {
              tween(_this3.diamonds).to(1.5, {
                scale: v3(0.4, 0.4),
                position: v3(-200, 450)
              }).call(function () {
                (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
                  error: Error()
                }), tyqSDK) : tyqSDK).Diamonds = 2;

                if (_this3.callBack) {
                  _this3.callBack();
                }

                _this3.node.destroy();
              }).start();
            }).start();
          }, function () {
            if (_this3.callBack) {
              _this3.callBack();
            }

            _this3.node.destroy();
          });
        };

        _proto.update = function update(deltaTime) {
          if (this.progress.progress > 0) {
            this.progress.progress -= this.cutNum;
          }
        };

        return tyq_crazyBox;
      }(Component), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "box", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "progress", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "Eggshell", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "diamonds", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_crazyBox.js.map