System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./tyq-sdk"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Component, Node, SpriteFrame, Texture2D, SpriteComponent, assetManager, tyqSDK, _dec, _class, _crd, ccclass, property, TyqIbanner;

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _reportPossibleCrUseOfgameInfo(extras) {
    _reporterNs.report("gameInfo", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Component = _cc.Component;
      Node = _cc.Node;
      SpriteFrame = _cc.SpriteFrame;
      Texture2D = _cc.Texture2D;
      SpriteComponent = _cc.SpriteComponent;
      assetManager = _cc.assetManager;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "857774NXl5MLIlwEK/FjaeP", "tyq_ibanner", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("TyqIbanner", TyqIbanner = (_dec = ccclass('TyqIbanner'), _dec(_class = /*#__PURE__*/function (_Component) {
        _inheritsLoose(TyqIbanner, _Component);

        function TyqIbanner() {
          return _Component.apply(this, arguments) || this;
        }

        var _proto = TyqIbanner.prototype;

        _proto.start = function start() {
          var _this = this;

          if ((_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).gameBannerList.length == 0) return;
          var gameValeu = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).gameBannerList[0];
          assetManager.loadRemote(gameValeu.gameImg, function (err, spf) {
            if (err) {
              console.log(err);
              return;
            }

            ;
            var sp = new SpriteFrame();
            var tex = new Texture2D();
            tex.image = spf;
            sp.texture = tex;
            _this.node.getComponent(SpriteComponent).spriteFrame = sp;
          });
          this.node.on(Node.EventType.TOUCH_END, function () {
            (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
              error: Error()
            }), tyqSDK) : tyqSDK).navigateToVideoView(gameValeu, "banner");
          }, this); // Your initialization goes here.
        } // update (deltaTime: number) {
        //     // Your update function goes here.
        // }
        ;

        return TyqIbanner;
      }(Component)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_ibanner.js.map