System.register(["cce:/internal/code-quality/cr.mjs", "cc", "./SDKbaseView", "./tyq-sdk", "./tyq_gameItem"], function (_export, _context) {
  "use strict";

  var _reporterNs, _cclegacy, _decorator, Node, Prefab, instantiate, SDKbaseView, tyqSDK, tyq_gameItem, _dec, _dec2, _dec3, _dec4, _dec5, _class, _class2, _descriptor, _descriptor2, _descriptor3, _descriptor4, _temp, _crd, ccclass, property, tyq_moreGamePanel;

  function _initializerDefineProperty(target, property, descriptor, context) { if (!descriptor) return; Object.defineProperty(target, property, { enumerable: descriptor.enumerable, configurable: descriptor.configurable, writable: descriptor.writable, value: descriptor.initializer ? descriptor.initializer.call(context) : void 0 }); }

  function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

  function _inheritsLoose(subClass, superClass) { subClass.prototype = Object.create(superClass.prototype); subClass.prototype.constructor = subClass; _setPrototypeOf(subClass, superClass); }

  function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

  function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

  function _applyDecoratedDescriptor(target, property, decorators, descriptor, context) { var desc = {}; Object.keys(descriptor).forEach(function (key) { desc[key] = descriptor[key]; }); desc.enumerable = !!desc.enumerable; desc.configurable = !!desc.configurable; if ('value' in desc || desc.initializer) { desc.writable = true; } desc = decorators.slice().reverse().reduce(function (desc, decorator) { return decorator(target, property, desc) || desc; }, desc); if (context && desc.initializer !== void 0) { desc.value = desc.initializer ? desc.initializer.call(context) : void 0; desc.initializer = undefined; } if (desc.initializer === void 0) { Object.defineProperty(target, property, desc); desc = null; } return desc; }

  function _initializerWarningHelper(descriptor, context) { throw new Error('Decorating class property failed. Please ensure that ' + 'proposal-class-properties is enabled and runs after the decorators transform.'); }

  function _reportPossibleCrUseOfSDKbaseView(extras) {
    _reporterNs.report("SDKbaseView", "./SDKbaseView", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyqSDK(extras) {
    _reporterNs.report("tyqSDK", "./tyq-sdk", _context.meta, extras);
  }

  function _reportPossibleCrUseOftyq_gameItem(extras) {
    _reporterNs.report("tyq_gameItem", "./tyq_gameItem", _context.meta, extras);
  }

  return {
    setters: [function (_cceInternalCodeQualityCrMjs) {
      _reporterNs = _cceInternalCodeQualityCrMjs;
    }, function (_cc) {
      _cclegacy = _cc.cclegacy;
      _decorator = _cc._decorator;
      Node = _cc.Node;
      Prefab = _cc.Prefab;
      instantiate = _cc.instantiate;
    }, function (_SDKbaseView) {
      SDKbaseView = _SDKbaseView.SDKbaseView;
    }, function (_tyqSdk) {
      tyqSDK = _tyqSdk.tyqSDK;
    }, function (_tyq_gameItem) {
      tyq_gameItem = _tyq_gameItem.tyq_gameItem;
    }],
    execute: function () {
      _crd = true;

      _cclegacy._RF.push({}, "d0636hfg4lN+4A7/ppFpCZT", "tyq_moreGamePanel", undefined);

      ccclass = _decorator.ccclass;
      property = _decorator.property;

      _export("tyq_moreGamePanel", tyq_moreGamePanel = (_dec = ccclass('tyq_moreGamePanel'), _dec2 = property({
        type: Node,
        tooltip: "今日最佳的layout"
      }), _dec3 = property({
        type: Node,
        tooltip: "编辑精选的layout"
      }), _dec4 = property({
        type: Node,
        tooltip: "返回"
      }), _dec5 = property({
        type: Prefab,
        tooltip: "游戏item预制体"
      }), _dec(_class = (_class2 = (_temp = /*#__PURE__*/function (_ref) {
        _inheritsLoose(tyq_moreGamePanel, _ref);

        function tyq_moreGamePanel() {
          var _this;

          for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
            args[_key] = arguments[_key];
          }

          _this = _ref.call.apply(_ref, [this].concat(args)) || this;

          _initializerDefineProperty(_assertThisInitialized(_this), "layOut1", _descriptor, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "layOut2", _descriptor2, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "back", _descriptor3, _assertThisInitialized(_this));

          _initializerDefineProperty(_assertThisInitialized(_this), "tyq_gameItem", _descriptor4, _assertThisInitialized(_this));

          return _this;
        }

        var _proto = tyq_moreGamePanel.prototype;

        _proto.start = function start() {
          var arry = (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).gameList;
          arry.sort(this.randList);

          for (var i = 0; i < 6; i++) {
            var node = instantiate(this.tyq_gameItem);
            node.parent = this.layOut1;
            node.getComponent(_crd && tyq_gameItem === void 0 ? (_reportPossibleCrUseOftyq_gameItem({
              error: Error()
            }), tyq_gameItem) : tyq_gameItem).init(arry[i]);
          }

          if (arry.length < 9) return;

          for (var _i = 6; _i < arry.length; _i++) {
            var _node = instantiate(this.tyq_gameItem);

            _node.parent = this.layOut2;

            _node.getComponent(_crd && tyq_gameItem === void 0 ? (_reportPossibleCrUseOftyq_gameItem({
              error: Error()
            }), tyq_gameItem) : tyq_gameItem).init(arry[_i]);
          }

          this.bindButton(this.back, this.backFun);
        }
        /**返回 */
        ;

        _proto.backFun = function backFun() {
          (_crd && tyqSDK === void 0 ? (_reportPossibleCrUseOftyqSDK({
            error: Error()
          }), tyqSDK) : tyqSDK).hideMoreGameBoxPanel();
        }
        /**随机数组 */
        ;

        _proto.randList = function randList() {
          return 0.5 - Math.random();
        };

        _proto.onEnable = function onEnable() {
          this.node.setSiblingIndex(this.node.parent.children.length - 1);
        };

        return tyq_moreGamePanel;
      }(_crd && SDKbaseView === void 0 ? (_reportPossibleCrUseOfSDKbaseView({
        error: Error()
      }), SDKbaseView) : SDKbaseView), _temp), (_descriptor = _applyDecoratedDescriptor(_class2.prototype, "layOut1", [_dec2], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor2 = _applyDecoratedDescriptor(_class2.prototype, "layOut2", [_dec3], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor3 = _applyDecoratedDescriptor(_class2.prototype, "back", [_dec4], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      }), _descriptor4 = _applyDecoratedDescriptor(_class2.prototype, "tyq_gameItem", [_dec5], {
        configurable: true,
        enumerable: true,
        writable: true,
        initializer: function initializer() {
          return null;
        }
      })), _class2)) || _class));

      _cclegacy._RF.pop();

      _crd = false;
    }
  };
});
//# sourceMappingURL=tyq_moreGamePanel.js.map